/*
 *	clipfix.h
 *
 *	Œ菬Cu`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Mon Mar 24 04:30:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_FIX_H__
#define __CLIP_FIX_H__

/*****************************************************************************
 *	fixed
 *****************************************************************************/

#define FRACT_BITS	10			/* rbg */
#define VALUE_BITS	(32 - FRACT_BITS)	/* rbg */
#define FIXED_SCALE	(1 << FRACT_BITS)	/* Œ菬XP[l */
#define FRACT_MASK	((1 << FRACT_BITS) - 1)	/* rbg}XN */

/* Œ菬f[^^̒`łB
 * * struct _fixed ͖`łBȂ킿Afixed̎Ԃ͖`\̂ւ̃|C^łB
 * - fixed̂悤ɒ`ŔAĒʏ̉ZqKpłȂ悤ɂ邽߂łB
 *   
 *	(1) typedef int fixed;
 *	(2) typedef void* fixed;
 *   ̂悤ɒ`ꍇÂ悤ȌZʂĂ܂܂B((1),(2))
 *	fixed f;
 *	int n;
 *	...
 *	f += n; // { f = fadd(f, fild(n)) Ƃׂ
 * - ʏ̉ZqKp邽߂̕ʂ̕@ƂāAfixed\̂ƂĒ`@܂B
 *	(3) typedef struct _fixed {
 *		unsigned fract:FRACT_BITS;
 *		int value:VALUE_BITS;
 *	    } fixed;
 *   (3)̕@̂ȂŔAs̒ቺ邽߂łB
 *   gcc33ł́A\̈̓WX^nł͂ȂX^bNnƂȂ܂B
 *   Ƃ\̃TCY32rbgȓłĂAɃX^bNnƂȂ܂B
 *   lZŃX^bNnƎs傫ቺ̂ŁA̕@͍̂܂łB
 *   ܂A|C^Ɋrׂ(int)ւ̃LXgAZ}N`̂Ȃ_A
 *   (3)̕@̂ȂR̂ЂƂłB
 */
typedef struct _fixed* fixed;

/* orŒ菬iO[oϐ̏Ɏg߁ACC֐ł͂Ȃ}NƂĒ`j */
#define fld(a)		((fixed)(int)((a) * FIXED_SCALE))
/*           Œ菬iO[oϐ̏Ɏg߁ACC֐ł͂Ȃ}NƂĒ`j */
#define fild(a)		((fixed)     ((a) * FIXED_SCALE))
/* Œ菬 */
static inline float fst(fixed a) { return (float)(int)a / FIXED_SCALE; }
/* Œ菬 */
static inline int fist(fixed a) { return (int)a >> FRACT_BITS; }
/* ] */
static inline fixed fchs(fixed a) { return (fixed)-(int)a; }
/* Βlifabs()͕WCCu̓֐ƂԂ̂ŉj */
static inline fixed ffabs(fixed a) { return (int)a >= 0 ? a : fchs(a); }
/* Z */
static inline fixed fadd (fixed a, fixed b) { return (fixed)((int) a + (int)     b ); }
static inline fixed fiadd(fixed a, int   b) { return (fixed)((int) a + (int)fild(b)); }
/* Z */
static inline fixed fsub (fixed a, fixed b) { return (fixed)((int) a - (int)     b ); }
static inline fixed fisub(fixed a, int   b) { return (fixed)((int) a - (int)fild(b)); }
/* r */
static inline int fcom (fixed a, fixed b) { return (int)fsub (a, b); }
static inline int ficom(fixed a, int   b) { return (int)fisub(a, b); }
/* Z */
              fixed fmul (fixed a, fixed b);
static inline fixed fimul(fixed a, int   b) { return (fixed)((int)a * b); }
/* Z */
              fixed fdiv (fixed a, fixed b);
static inline fixed fidiv(fixed a, int   b) { return (fixed)((int)a / b); }
/* iw肵ꍇ̌ʂ͖`łj */
fixed fsqrt(fixed a);
/* Op֐ */
fixed fsin(fixed a);		//80387ȍ~
fixed fcos(fixed a);		//80387ȍ~
fixed ftan(fixed a);		//80x87łfptan
fixed fasin(fixed a);		//80x87ɂ͂Ȃ
fixed facos(fixed a);		//80x87ɂ͂Ȃ
fixed fatan(fixed a);		//80x87łfpatan
fixed fatan2(fixed y, fixed x);	//80x87ɂ͂Ȃ

/* ~
 * * {̌덷h߁A/22{,4{Ē`܂B
 * * Op֐e[uւ̃ItZbgƂĂp邽߁Aint^float^̗`܂B
 */
#if FIXED_SCALE != 1024
#error Œ菬p[^zlƈقȂ܂B
#endif
#define _PI_2	1608	/* 3.14159265358979323846 / 2 * 1024 = 1608.49543863797413809152 */
#define _PI	3216	/* 3.14159265358979323846     * 1024 = 3216.99087727594827618304 */
#define _PI2	6432	/* 3.14159265358979323846 * 2 * 1024 = 6433.98175455189655236608 ({6433łA_PI_24{ɍ킹6432Ƃ܂) */
#define PI_2	((fixed)_PI_2)
#define PI	((fixed)_PI  )
#define PI2	((fixed)_PI2 )

/*****************************************************************************
 *	vector
 *****************************************************************************/

/* xNg\̂̒`łB */
typedef struct _vector {
	fixed x;	/* X */
	fixed y;	/* Y */
	fixed z;	/* Z */
} vector;

/* `ς݂̃xNgłB */
extern const vector VECTOR_0;	/* [xNg */
extern const vector VECTOR_X;	/* XPʃxNg */
extern const vector VECTOR_Y;	/* YPʃxNg */
extern const vector VECTOR_Z;	/* ZPʃxNg */

/* xNg̏֐͗pӂĂ܂B
 * GCCg@\𗘗pāÂ悤ɏ܂B
 *	vector v;
 *	...
 *	v = (vector){x_value,y_value,z_value};
 *	...
 */

/* xNg̊e𕄍]܂B
 * [in]
 *	a		]xNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vchs(vector a);

/* xNg̊eZ܂B
 * [in]
 *	a,b		ZxNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vadd(vector a, vector b);

/* xNg̊eZ܂B
 * [in]
 *	a,b		ZxNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vsub(vector a, vector b);

/* xNg̊eZ܂B
 * [in]
 *	a,b		ZxNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vmul(vector a, vector b);

/* xNg̊e𓯂lŏZ܂B
 * [in]
 *	a		ZxNgB
 *	s		ZlB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vfmul(vector a, fixed b); // Œ菬
vector vimul(vector a, int   b); // 

/* xNg̊eZ܂B
 * [in]
 *	a,b		ZxNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vdiv(vector a, vector b);

/* xNg̊e𓯂lŏZ܂B
 * [in]
 *	a		ZxNgB
 *	s		ZlB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vfdiv(vector a, fixed b); // Œ菬
vector vidiv(vector a, int   b); // 

/* xNg̓(dot product)߂܂B
 * [in]
 *	a,b		ς߂xNgB
 * [out]
 *	߂l		ς̒lB
 * [note]
 * 	* ς̒`: aEb = |a||b|cos
 */
fixed vdot(vector a, vector b);

/* xNg̊O(cross product)߂܂B
 * [in]
 *	a,b		Oς߂xNgB
 * [out]
 *	߂l		ʂ̃xNgB
 * [note]
 * 	* Oς̒`: a~b = |a||b|sin*c
 * 	  AcabɐȒPʃxNgƂB
 */
vector vcross(vector a, vector b);

/* xNg𐳋K(normalize)܂B
 * [in]
 *	a		KxNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vnormal(vector a);

/* xNg̒(magnitude)߂܂B
 * [in]
 *	a		߂xNgB
 * [out]
 * 	߂l		ʂ̒lB
 */
fixed vmag(vector a);

/* xNg̒̓(square magnitude)߂܂B
 * [in]
 *	a		̓߂xNgB
 * [out]
 * 	߂l		ʂ̒lB
 */
fixed vmag2(vector a);

/* ˃xNg߂܂B
 * [in]
 *	N		˖ʂ̖@xNgB
 *	E		˓_ւ̃xNgB
 *			ƁAťxNgłB
 * [out]
 *	߂l		ʂ̃xNgB
 * [note]
 *	* ˃xNǧ́A̒ʂłB
 *		R = 2(EEN)N - E
 *	  l:
 *	  xNgE,N_ƂāAEN֐낵ꍇA
 *	  ̐NƌP_
 *		P = (EEN)N
 *	  łBȂȂA(EEN)̓xNgE,N̂ȂpcoslłB
 *	  ŔAPEɓ_Ώ̂ȈʒuAȂ킿A
 *	  EAE->P̓{i񂾈ʒułB
 *		R = E + 2(P - E)
 *		  = 2P - E
 *		  = 2(EEN)N - E
 *	  ȏłB
 *	* xNgE,ŃAKĂȂ΂܂B
 *	  KĂȂꍇAԈʂƂȂ܂B
 *	  ۂɂ́AEKĂȂꍇ́A
 *	    PɌʂ̃xNg̑傫EɓȂ邾̂悤Ɏv܂B
 *	    (mF)
 *	* xNgÉA"t"xNgł邱ƂɒӂĂB
 *	  ̊֐́A˃xNg߂ƌA
 *	  NƂāAEɐΏ̂ȃxNg߂AƌmłB
 *	  ExNgƓɎg₷Ǝv̂łA
 *	  Ƃċt̕ʓIȂ悤Ȃ̂ŁAȂĂ݂܂B
 */
vector vreflect(vector N, vector E);

/*****************************************************************************
 *	matrix
 *****************************************************************************/

/* s\̂̒`łB */
typedef struct _matrix {
	/* | a00 a10 a20 |T = pxNgX */
	/* | a01 a11 a21 |T = pxNgY */
	/* | a02 a12 a22 |T = pxNgZ */
	/* | a03 a13 a23 |T = sړ        */
	fixed a00, a01, a02, a03;
	fixed a10, a11, a12, a13;
	fixed a20, a21, a22, a23;
} matrix;

/* `ς݂̍słB */
extern const matrix MATRIX_I;	/* P(identity)s */

/* s̏֐͗pӂĂ܂B
 * GCCg@\𗘗pāÂ悤ɏ܂B
 *	matrix m;
 *	...
 *	m = (matrix){a00_value,a01_value,...,a23_value};
 *	...
 */

/* ]u(transpose)s߂܂B
 * [in]
 *	a		]usB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* sړ͏A(0,0,0)ƂȂ܂B
 */
matrix mxpose(matrix a);

/* ts(inverse)߂܂B
 * [in]
 *	a		ts߂sB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* stȍsw肵ꍇ̌ʂ́A`łB
 */
matrix minv(matrix a);

/* K(normalized orthogonal)s̋ts߂܂B
 * [in]
 *	a		ts߂sB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* minv()AłB
 *	* KłȂsw肵ꍇ̌ʂ́A`łB
 */
matrix minvno(matrix a);

/* xNgϊ(transform)܂B
 * [in]
 *	a		sB
 *	b		xNgB
 * [out]
 *	߂l		ʂ̃xNgB
 */
vector vxform(matrix a, vector b);

/* sϊ(transform)܂B
 * [in]
 *	a,b		sB
 *	b00`b23	s̐B
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mxform(matrix a, matrix b);

/*  sړ(translate)s܂B
 * [in]
 *	a		sB
 *	x,y,z		X,Y,Z̕sړB
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mxlate(matrix a, fixed x, fixed y, fixed z);

/* gEk(scale)s܂B
 * [in]
 *	a		sB
 *	x,y,z		X,Y,Z̊gEkWB
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mscale(matrix a, fixed x, fixed y, fixed z);

/* X,Y,ZƂWŁAgEks܂B
 * [in]
 *	a		sB
 *	s		gEkWB
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mfscale(matrix a, fixed s);

/* Cӎ](rotate)s܂B
 * [in]
 *	a		sB
 *	x,y,z		]̃xNgB
 *	d		]pxB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* ]̃xNǵAKĂȂĂ\܂B
 */
matrix mrot(matrix a, fixed x, fixed y, fixed z, fixed d);

/* Œꎲ](rotate)s܂B
 * [in]
 *	a		sB
 *	d		]pxB
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mrotx(matrix a, fixed d);
matrix mroty(matrix a, fixed d);
matrix mrotz(matrix a, fixed d);

/* Œ񎲉](rotate)s܂B
 * [in]
 *	a		sB
 *	x,y,z		]pxB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* O̉]pxw̌ʂ͋tłB
 *	  ŒO][note]QƂĂB
 */
matrix mrotxyx(matrix a, fixed x, fixed y, fixed z);
matrix mrotxzx(matrix a, fixed x, fixed y, fixed z);
matrix mrotyxy(matrix a, fixed x, fixed y, fixed z);
matrix mrotyzy(matrix a, fixed x, fixed y, fixed z);
matrix mrotzxz(matrix a, fixed x, fixed y, fixed z);
matrix mrotzyz(matrix a, fixed x, fixed y, fixed z);

/* ŒO](rotate)s܂B
 * [in]
 *	a		sB
 *	x,y,z		]pxB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* s]ûŁAťʂɂȂ܂B
 *	  Ⴆ΁A
 *		mrotxyz(o, a, x, y, z)
 *	  ́A
 *		mrotz(o, a, z);
 *		mroty(o, o, y);
 *		mrotx(o, o, x);
 *	  ƓʂƂȂ܂B
 *	  ֐̖Oς̂m܂񂪁A
 *	  őɎgȂ̂ŁAƂ肠̂܂܂ɂĂ܂B
 */
matrix mrotxyz(matrix a, fixed x, fixed y, fixed z);
matrix mrotxzy(matrix a, fixed x, fixed y, fixed z);
matrix mrotyxz(matrix a, fixed x, fixed y, fixed z);
matrix mrotyzx(matrix a, fixed x, fixed y, fixed z);
matrix mrotzxy(matrix a, fixed x, fixed y, fixed z);
matrix mrotzyx(matrix a, fixed x, fixed y, fixed z);

/* ]̃xNgƁA]px߂܂B
 * [in]
 *	v		]̃xNgi[xNgB
 *	a		ׂsB
 * [out]
 *	߂l		]pxB
 *	*v		]̃xNgB
 */
fixed mrotget(vector* v, matrix a);

/* pϊ(orientate)s܂B
 * [in]
 *	a		sB
 *	dx,dy,dz	Z̎pxNgB
 *	ux,uy,uz	Y̎pxNgB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* pxNǵAKĂȂĂ\܂B
 */
matrix morient(matrix a,
	fixed dx, fixed dy, fixed dz,
	fixed ux, fixed uy, fixed uz);

/* _ϊs܂B
 * [in]
 *	a		sB
 *	ex,ey,ez	_WB
 *	cx,cy,cz	_WB
 *	bank		oNpxB
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mlookat(matrix a,
	fixed ex, fixed ey, fixed ez,
	fixed cx, fixed cy, fixed cz,
	fixed bank);

/* ϊ(frustum)s܂B
 * [in]
 *	a		sB
 *	width		eʂ̕              (Wn)
 *	height		eʂ̍            (Wn)
 *	front		tgNbsO(Wn)
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* Sȓϊł͂ȂAZW͎Ŵ܂ܕω܂B
 *	  ȂȂÃCuł͍s3x4ŕ\Ă̂ŁA
 *	  ZW̐Klϊs\ȂłB
 *	  Azobt@ł͂ȂAz\[gz肵Ă̂ŁA
 *	  p͂ȂƎv܂B
 *	* ̍sōWϊł́AX,YW͐K܂B
 *	  x=x/z,y=y/z sāAx,y(-1,1)ɓeKv܂B
 */
matrix mfrustum(matrix a, fixed width, fixed height, fixed front);

/* ϊ(perspective)s܂B
 * [in]
 *	a		sB
 *	fovy		pxB
 *	aspect		AXyNg()
 *	front		tgNbsO(Wn)
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* mfrustum()̃RgQƂĂB
 */
matrix mperspect(matrix a, fixed fovy, fixed aspect, fixed front);

/* r[|[gϊ(viewport)s܂B
 * [in]
 *	a		sB
 *	left,top	r[|[g_W(XN[Wn)
 *	width,height	r[|[gTCY  (XN[Wn)
 *			^͌Œ菬ł͂Ȃł邱Ƃ
 *			  ӂĂB
 * [out]
 *	߂l		ʂ̍sB
 * [note]
 *	* ϊ -> x=x/z,y=y/z -> r[|[gϊ
 *	  ̏œKpꍇ́Amviewport()gĂB
 *	* ϊ -> r[|[gϊ -> x=x/z,y=y/z
 *	  ̏œKpꍇ́Amviewportz()gĂB
 *	* mviewport()gWϊ̎菇́ÂƂłB
 *		1. T = fϊ * _ϊ * ϊ ɂWϊ
 *		2. ZNbsO
 *		3. x = x / z, y = y / z
 *		4. T = r[|[gϊ ɂWϊ
 *		5. XYNbsO
 *	* ɑ΂Amviewportz()gꍇ́A
 *		1. T = fϊ * _ϊ * ϊ * r[|[gϊ
 *	  	   ɂAWϊ
 *		2. ZNbsO
 *		3. x = x / z, y = y / z
 *		4. XYNbsO
 *	  ƂȂA菇炷Ƃł܂B
 */
matrix mviewport (matrix a, int left, int top, int width, int height);
matrix mviewportz(matrix a, int left, int top, int width, int height);

/* eϊs܂B
 * [in]
 *	a		sB
 *	Lx,Ly,Lz	xNg
 *	Gx,Gy,Gz	eʏ̈_(C)̍W
 *	Nx,Ny,Nz	eʂ̖@xNg
 * [out]
 *	߂l		ʂ̍sB
 */
matrix mshadow(matrix a,
	fixed Lx, fixed Ly, fixed Lz,
	fixed Gx, fixed Gy, fixed Gz,
	fixed Nx, fixed Ny, fixed Nz);

#endif /*__CLIP_FIX_H__*/
