/*	
 *	cliprend.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Feb 13 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Fri Mar  8 07:00:00 JST 2002 Naoyuki Sawa
 *	- render_line()ŏI_NbsOꂽɁA
 *	  ʒ[1sNZԂoĂ܂CB
 *	* Wed Apr 24 10:11:00 JST 2002 Naoyuki Sawa
 *	- render_polygon()ǉB
 *	* Wed Jun  5 13:51:00 JST 2002 Naoyuki Sawa
 *	- render_point()ǉB
 *	* Wed Jun 18 21:39:00 JST 2002 Naoyuki Sawa
 *	- render_fill()ǉB
 *	* Sat Jul  6 08:42:00 JST 2002 Naoyuki Sawa
 *	- surface_point()ǉB
 *	* Sat Jul  6 17:51:00 JST 2002 Naoyuki Sawa
 *	- render_fill()̊֐render_paint()ɕύXB
 *	- render_rectangle()ǉB
 *	* Thu Jul 25 04:07:00 JST 2002 Naoyuki Sawa
 *	- render_rectangle_fill()ǉB
 *	* Sun Jul 28 16:56:00 JST 2002 Naoyuki Sawa
 *	- render_paint()ɖ߂l(hsNZ)ǉB
 *	* Sat Sep 21 23:02:00 JST 2002 Naoyuki Sawa
 *	- render_dashes()ǉB
 *	* Sat Oct 21 15:58:00 JST 2002 Naoyuki Sawa
 *	- render_dashes()ɖ߂lǉB
 *	* Sat Mar  8 06:23:00 JST 2003 Naoyuki Sawa
 *	- `p[N(xformed_vectors[],clip_vertices[]Ȃ)_def_vbuff[]ɊmہB
 *	* Wed Mar 26 05:00:00 JST 2003 Naoyuki Sawa
 *	- Œ菬ύXɂAWIgXe[W啝ɉB
 *	  ł̋\[X keep/ŉZ`R[hۑ ɕۑĂ܂B
 *	  Œ菬łWbN͕łƓŁAǐ͕ł̂̕ŁA
 *	  ł̋\[X͔jȂŉB
 *	* Sun Mar 30 19:00:00 JST 2003 Naoyuki Sawa
 *	- XLC`֐AZuō܂B40%炢Ȃ܂B
 *	  NOASMV{̒`/`ɂāAC[`ƃAZu[`؂ւ܂B
 *	- ܂͎gppx̍AyŕAcolorE2bitE2bitmaskAZu܂B
 *	  ̑̃XLC`֐AKvɉăAZu\łB
 *	  draw_scanline_wz_2bitmaskS@\o[Wł̂ŁAɍOKƎv܂B
 */
#include "clip.h"

/* NOASM`C[`A`Ȃasm[`g܂B */
#undef NOASM	/* ܂mɖ`ɂŁc */
//#define NOASM	/* KvɉĒ`Ăi`ƒxȂ܂j */

/*****************************************************************************
 *	
 *****************************************************************************/

TEXTURE*
texture_init(TEXTURE* texture, const void* data)
{
	TEXTUREHEADER* header;

	header = (TEXTUREHEADER*)data;

	/* wb_܂B
	 * * P/ECE̎dlɁu1bitf[^masktv(bpp=1,mask=1)݂͑܂񂪁A
	 *   {Cuł́ALȃeNX``ƂĂƂėp\Ȃ̂ŁA
	 *   G[ɂ͂܂B
	 * * eNZWƂĎw\Ȃ̂0`255ɐ܂A
	 *   eNX`̂̃TCY256hbgȏł\܂B
	 *   ]āAł̓TCY̏͌Ă܂B
	 */
	if(strncmp((char*)&header->head, "PMBP", 4) != 0) DIE();
	if(header->bpp  != 1 && header->bpp  != 2) DIE();
	if(header->mask != 0 && header->mask != 1) DIE();
	if(header->w < 8 || (header->w & 7) != 0) DIE();
	/* if(header->h < 8 || (header->h & 7) != 0) DIE(); -> CFcTCY͔CӂłB */

	/* eNX`wb_ƃ|C^i[܂B */
	memset(texture, 0, sizeof(TEXTURE));
	texture->header = *header;
	texture->buf  = (unsigned char*)(header + 1);
	if(header->mask) {
		texture->mask = (unsigned char*)(header + 1) +
				header->w * header->h / (8 / header->bpp);
	}

	return texture;
}

void
surface_clear(SURFACE* surface, int color)
{
	int n;

	n = surface->w * surface->h;
	if(surface->vbuff != NULL) memset(surface->vbuff, color, n);
	if(surface->zbuff != NULL) memset(surface->zbuff, 0xFF, n);
}

int
surface_point(SURFACE* surface, int x, int y)
{
	return 0 <= x && x <= surface->w - 1 &&
	       0 <= y && y <= surface->h - 1 ?
		surface->vbuff[surface->w * y + x] : -1;
}

/*****************************************************************************
 *	RENDER
 *****************************************************************************/

#define N_VERTICES_MAX	8	/* 1|S̍ő咸_ */

/* NbsOp_ */
typedef struct _CLIPVERTEX {
	fixed x, y, z;		/* + 0,12 _W       */
	fixed s, t;		/* +12, 8 eNX`W */
				/* =20                   */
} CLIPVERTEX;

/* `p_ */
typedef struct _RENDVERTEX {
	unsigned short x, y;	/* + 0,4 _W               */
	unsigned short z;	/* + 4,2 yl(8.8bit)           */
	unsigned short s, t;	/* + 6,4 eNX`W(8.8bit) */
				/* =10                          */
} RENDVERTEX;

/* DDA */
typedef struct _DDA {
	int n;			/* + 0,4 [̑     */
	int d;			/* + 4,4 [             */
	int u;			/* + 8,4 ̕ω     */
	int v;			/* +12,4 Jグ̕ω */
				/* =16                    */
} DDA;

/* ÓIȃ[NGAA_def_vbuff[]Ɋmۂ邽߂̍\̂łB */
typedef struct _RENDER_WORK {
	vector xformed_vectors[255];			/* 12*255=3060: ϊςݒ_Wobt@iMESH.nv8rbgȂ̂ŁAő255_łj */
	CLIPVERTEX clip_vertices[2][N_VERTICES_MAX];	/* 20*2*8= 320: NbsOp_obt@         */
	RENDVERTEX rend_vertices[N_VERTICES_MAX];	/* 10*8  =  80: `p_obt@                 */
} RENDER_WORK;						/* v = 3460: _def_vbuff[128*88=11264]̃TCY𒴂ȂƁIi܂3{ȏ]T܂j */
#define render_work	((RENDER_WORK*)_def_vbuff)	/* `pꎞ[ŃA_def_vbuff[]Ɋmۂ܂B */
							/* ̃[N̓[J֐Ԃ̘Â݂ɗpAO[o֐ԂŕێKv͂Ȃ̂ŁA */
							/* {IɃ[U[AvP[VӎKv͂܂B */
							/* A_def_vbuff[]ɕ`悵悤ƂƁA`撆Ƀ[Nj󂳂A삵܂B */
							/* `^[Qbg_def_vbuff[]w肵Ȃ悤AӂB */

static int  clip_z(RENDER* render, int nsrc);
static int clip_xy(RENDER* render, int nsrc);

/* draw_scanline_*_*()ֈnp[^̍\̂łB
 * draw_scanline_*_*()̓AZuō̂ŁAmɃItZbgŒƂ邽߂ɁA̍\̂pӂ܂B
 */
typedef struct _DSLPARAM {
	/* T[tFCX */
	unsigned short surface_w;			/*  0, 2:  */
	unsigned short surface_h;			/*  2, 2:  */
	unsigned char* surface_vbuff;			/*  4, 4: J[obt@ */
	unsigned char* surface_zbuff;			/*  8, 4: yobt@ */
	/* eNX` */
	unsigned short texture_w;			/* 12, 2:  */
	unsigned short texture_h;			/* 14, 2:  */
	unsigned char* texture_buf;			/* 16, 4: C[W */
	unsigned char* texture_mask;			/* 20, 4: }XN */
	/* J[ */
	unsigned char back_color;			/* 24, 1: wiF */
	unsigned char fore_color;			/* 25, 1: OiF */
} DSLPARAM;
typedef void (*DSLPROC)(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);

/* yRyA */
static void draw_primitive_wz(RENDER* render, int n_vertices, int color);
static DSLPROC select_draw_scanline_wz(DSLPARAM* param, RENDER* render, int color);
/* staticɂƁAasmŒڎƂ"static֐`"xôŁAdȂO[oɂ܂ */
/*static*/ void draw_scanline_wz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_wz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_wz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_wz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_wz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/* yRyAȂ */
static void draw_primitive_woz(RENDER* render, int n_vertices, int color);
static DSLPROC select_draw_scanline_woz(DSLPARAM* param, RENDER* render, int color);
/* staticɂƁAasmŒڎƂ"static֐`"xôŁAdȂO[oɂ܂ */
/*static*/ void draw_scanline_woz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_woz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_woz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_woz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/*static*/ void draw_scanline_woz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);

void
render_init(RENDER* render, SURFACE* surface, int x, int y, int width, int height, fixed front, fixed back, fixed fovy)
{
	/* T[tFCXݒ肵܂B */
	render->surface = surface;

	/* r[|[g`ݒ肵܂B */
	if(width == 0) width = surface->w;
	if(height == 0) height = surface->h;
	render->left = x;
	render->top = y;
	render->right = x + width;
	render->bottom = y + height;
	if(render->left < 0 ) render->left = 0;
	if(render->top < 0 ) render->top = 0;
	if(render->right > surface->w) render->right = surface->w;
	if(render->bottom > surface->h) render->bottom = surface->h;

	/* NbsOݒ肵܂B */
	render->front = front;
	render->back = back;

	/* ReLXgX^bN܂B */
	render->context = render->context_stack;

	/* ϊs܂B */
	if(front != fild(0) || back != fild(0) || fovy != fild(0)) { /* 3D`悠H */
		render->context->matrix = MATRIX_I;
		render->context->matrix = mviewportz(render->context->matrix, x, y, width, height);
		render->context->matrix = mperspect (render->context->matrix, fovy, fidiv(fld(width), height), front);
	}

	/* eNX`܂B */
	render->context->texture = NULL;
}

void
render_save(RENDER* render)
{
	/* X^bNgbv𕡐܂B */
	if(++render->context == render->context_stack + RENDER_CONTEXT_STACK_SIZE) DIE();
	memcpy(render->context, render->context - 1, sizeof(RENDERCONTEXT));
}

void
render_restore(RENDER* render)
{
	/* X^bNgbv̂Ă܂B */
	if(render->context-- == render->context_stack) DIE();
}

void
render_point(RENDER* render, int x, int y, int color)
{
	SURFACE* surface;
	unsigned char* vptr;
	int ofs;

	/* T[tFCXoĂ܂B */
	surface = render->surface;

	/* r[|[g`OȂA`܂B */
	if(x < render->left || render->right  <= x ||
	   y < render->top  || render->bottom <= y) return;

	/* sNZAhX߂܂B */
	ofs = surface->w * y + x;
	vptr = surface->vbuff + ofs;

	/* sNZ`܂B */
	*vptr = color;
}

/* SĂ܂BxłB
 * Q[ł́AhԂvʂ͏ȂƎv̂ŁA
 * ̂܂܂łɖ͂ȂƎv܂B
 */
int
render_paint(RENDER* render, int x0, int y0, int color)
{
/* hԂ_X^bNTCYF
 * ƂAȂ蕡GȓhԂł24xŏ[łA
 * Ô߁A]TŁA傫߂ɎĂƂɂ܂B
 * ܂傫ƁAP/ECEł̓X^bNӂ̂ŁAӂB
 */
#define RENDER_PAINT_STACK_SIZE	64

	SURFACE* surface;
	short stack[RENDER_PAINT_STACK_SIZE][2]; /* ߖ̂short */
	int i_stack, ofs, x, y, x1, x2;
	unsigned char c;
	int cnt = 0; /* ɓhsNZJEg܂ */

	/* T[tFCXoĂ܂B */
	surface = render->surface;

	/* hԂJn_r[|[gOȂA܂B */
	if(x0 < render->left || render->right  - 1 < x0) return 0;
	if(y0 < render->top  || render->bottom - 1 < y0) return 0;

	/* hԂF擾܂B */
	ofs = surface->w * y0 + x0;
	c = surface->vbuff[ofs];

	/* hԂJn_ɓhԂFȂA܂B */
	/* if(c == color) return 0; */
	/* ->悭lÃ`FbN͕svłB
	 *   hԂJn_ɓhԂFȂA
	 *   1. X^bNɍŏ(x0,y0)ςށB
	 *   2. while()[v̒(x0,y0)oB
	 *   3. ɓhĂ̂ŁAcontinueŔ΂B
	 *   4. X^bN͋Ȃ̂ŁAIB
	 *   ƂȂAɏI܂B
	 */

	/* hԂJn_X^bNɐς݂܂B */
	stack[0][0] = x0;
	stack[0][1] = y0;
	i_stack = 1;

	/* hԂ_ȂȂ܂... */
	while(i_stack != 0) {
		/* hԂ_o܂B */
		i_stack--;
		x0 = stack[i_stack][0];
		y0 = stack[i_stack][1];

		/* ɓhĂA΂܂B */
		ofs = surface->w * y0 + x0;
		if(surface->vbuff[ofs] == color) continue;

		/* hF̍[T܂B */
		x1 = x0;
		for(;;) {
			x1--;
			if(x1 < render->left) break; /* r[|[gO */
			ofs = surface->w * y0 + x1;
			if(surface->vbuff[ofs] != c) break; /* ʐF */
		}
		x1++; /* s߂Ă̂Ŗ߂ */

		/* hF̉E[T܂B */
		x2 = x0;
		for(;;) {
			x2++;
			if(x2 > render->right - 1) break; /* r[|[gO */
			ofs = surface->w * y0 + x2;
			if(surface->vbuff[ofs] != c) break; /* ʐF */
		}
		x2--; /* s߂Ă̂Ŗ߂ */

		/* E̊ԂhԂ܂B */
		for(x = x1; x <= x2; x++) {
			ofs = surface->w * y0 + x;
			surface->vbuff[ofs] = color;
			cnt++; /* hsNZJEg */
			/* pceLCDTrans()ĂԂƁAhԂ̗lq1sNZPʂŊώ@ł܂B */
			/* pceLCDTrans() */
		}
		/* pceLCDTrans()ĂԂƁAhԂ̗lq1CPʂŊώ@ł܂B */
		/* pceLCDTrans() */

		/* ̃C̒B */
		if(y0 != render->top) {
			y = y0 - 1;
			x = x1;
			for(;;) {
				/* hF̎n܂T܂B */
				for(;;) {
					if(x > x2) break;
					ofs = surface->w * y + x;
					if(surface->vbuff[ofs] == c) break;
					x++;
				}
				if(x > x2) break; /* Ȃ */

				/* hF̏IT܂B */
				for(;;) {
					if(x > x2) break;
					ofs = surface->w * y + x;
					if(surface->vbuff[ofs] != c) break;
					x++;
				}

				/* hF̏ÏʒuX^bNɐς݂܂B */
				if(i_stack < RENDER_PAINT_STACK_SIZE) {
					stack[i_stack][0] = x - 1; /* s߂Ă̂Ŗ߂ */
					stack[i_stack][1] = y;
					i_stack++;
				}
			}
		}

		/* ̃C̒B */
		if(y0 != render->bottom - 1) {
			y = y0 + 1;
			x = x1;
			for(;;) {
				/* hF̎n܂T܂B */
				for(;;) {
					if(x > x2) break;
					ofs = surface->w * y + x;
					if(surface->vbuff[ofs] == c) break;
					x++;
				}
				if(x > x2) break; /* Ȃ */

				/* hF̏IT܂B */
				for(;;) {
					if(x > x2) break;
					ofs = surface->w * y + x;
					if(surface->vbuff[ofs] != c) break;
					x++;
				}

				/* hF̏ÏʒuX^bNɐς݂܂B */
				if(i_stack < RENDER_PAINT_STACK_SIZE) {
					stack[i_stack][0] = x - 1; /* s߂Ă̂Ŗ߂ */
					stack[i_stack][1] = y;
					i_stack++;
				}
			}
		}
	}

	return cnt;

#undef RENDER_PAINT_STACK_SIZE
}

void
render_line(RENDER* render, int x0, int y0, int x1, int y1, int color)
{
	/* NbsOp}NB */
#define CLIP(X, Y, A, B, OP, LIM) \
	if(!((X##A) OP (LIM))) { \
		if(!((X##B) OP (LIM))) { \
			return; \
		} else { \
			(Y##A) = (Y##A) + \
			((Y##B) - (Y##A)) * ((LIM) - (X##A)) / ((X##B) - (X##A)); \
			(X##A) = (LIM); \
			clipped |= (A); /* (x1,y1)Nbvclipped=1 */ \
		} \
	}

	SURFACE* surface;
	unsigned char* vptr;
	int nx, ny;
	int ux, uy;
	int d, n;
	int tmp, ofs;
	/* I_̃NbsOtOB
	 * l0ŁA(x1,y1)Nbv1ɂȂ܂B
	 * (x0,y0)Nbvꂽǂɂ͉e܂B
	 * ͏ɁA(x0,y0)(x1,y1)Ɍĕ`܂B
	 * Az肵Ă̂ŁAʏAI_͕`܂񂪁A
	 * (x1,y1)Nbvꂽꍇ̂݁AI_`܂B
	 */
	int clipped = 0;

	/* T[tFCXoĂ܂B */
	surface = render->surface;

	/* e_AE㉺ŃNbv܂B */
	CLIP(x, y, 0, 1, >=, render->left);
	CLIP(x, y, 0, 1, <=, render->right - 1);
	CLIP(x, y, 1, 0, >=, render->left);
	CLIP(x, y, 1, 0, <=, render->right - 1);
	CLIP(y, x, 0, 1, >=, render->top);
	CLIP(y, x, 0, 1, <=, render->bottom - 1);
	CLIP(y, x, 1, 0, >=, render->top);
	CLIP(y, x, 1, 0, <=, render->bottom - 1);

	/* n_AhX߂܂B */
	ofs = surface->w * y0 + x0;
	vptr = surface->vbuff + ofs;

	/* XDDAp^vZ܂B */
	if(x1 >= x0) {
		nx = x1 - x0;
		ux =  1;
	} else {
		nx = x0 - x1;
		ux = -1;
	}

	/* YDDAp^vZ܂B */
	if(y1 >= y0) {
		ny = y1 - y0;
		uy =  surface->w;
	} else {
		ny = y0 - y1;
		uy = -surface->w;
	}

	/* 厲(X)A𕛎(Y)Ƃ܂B */
	if(nx < ny) {
		tmp = x0; x0 = y0; y0 = tmp;
		tmp = x1; x1 = y1; y1 = tmp;
		tmp = nx; nx = ny; ny = tmp;
		tmp = ux; ux = uy; uy = tmp;
	}
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDA[vB */
	d = -nx;
	n = nx + clipped; /* I_NbvꂽAI_`B */
	do {
		*vptr = color;
		vptr += ux;
		d += ny * 2;
		if(d >= 0) {
			vptr += uy;
			d -= nx * 2;
		}
	} while(--n); /* I_͕`Ȃ̂ŁAvfNgłB   */
		      /* I_NbvꂽAI_`܂A */
		      /* ̏ꍇ́A[vOɗ\+1Ă̂ŁA */
		      /* ɂ悱ł̓vfNgłB   */

#undef CLIP
}

/* render_line()x[XɁAjp^[̎oǉ܂B
 * render_line()ύXECƂ́Arender_dashes()Ǐ]ĂB
 */
int
render_dashes(RENDER* render, int x0, int y0, int x1, int y1, unsigned i_pat, const unsigned char* pat, unsigned n_pat)
{
	/* NbsOp}NB */
#define CLIP(X, Y, A, B, OP, LIM) \
	if(!((X##A) OP (LIM))) { \
		if(!((X##B) OP (LIM))) { \
			return i_pat; \
		} else { \
			(Y##A) = (Y##A) + \
			((Y##B) - (Y##A)) * ((LIM) - (X##A)) / ((X##B) - (X##A)); \
			(X##A) = (LIM); \
			clipped |= (A); /* (x1,y1)Nbvclipped=1 */ \
		} \
	}

	SURFACE* surface;
	unsigned char *vptr, color;
	int nx, ny;
	int ux, uy;
	int d, n;
	int tmp, ofs;
	/* I_̃NbsOtOB
	 * l0ŁA(x1,y1)Nbv1ɂȂ܂B
	 * (x0,y0)Nbvꂽǂɂ͉e܂B
	 * ͏ɁA(x0,y0)(x1,y1)Ɍĕ`܂B
	 * Az肵Ă̂ŁAʏAI_͕`܂񂪁A
	 * (x1,y1)Nbvꂽꍇ̂݁AI_`܂B
	 */
	int clipped = 0;

	/* T[tFCXoĂ܂B */
	surface = render->surface;

	/* e_AE㉺ŃNbv܂B */
	CLIP(x, y, 0, 1, >=, render->left);
	CLIP(x, y, 0, 1, <=, render->right - 1);
	CLIP(x, y, 1, 0, >=, render->left);
	CLIP(x, y, 1, 0, <=, render->right - 1);
	CLIP(y, x, 0, 1, >=, render->top);
	CLIP(y, x, 0, 1, <=, render->bottom - 1);
	CLIP(y, x, 1, 0, >=, render->top);
	CLIP(y, x, 1, 0, <=, render->bottom - 1);

	/* n_AhX߂܂B */
	ofs = surface->w * y0 + x0;
	vptr = surface->vbuff + ofs;

	/* XDDAp^vZ܂B */
	if(x1 >= x0) {
		nx = x1 - x0;
		ux =  1;
	} else {
		nx = x0 - x1;
		ux = -1;
	}

	/* YDDAp^vZ܂B */
	if(y1 >= y0) {
		ny = y1 - y0;
		uy =  surface->w;
	} else {
		ny = y0 - y1;
		uy = -surface->w;
	}

	/* 厲(X)A𕛎(Y)Ƃ܂B */
	if(nx < ny) {
		tmp = x0; x0 = y0; y0 = tmp;
		tmp = x1; x1 = y1; y1 = tmp;
		tmp = nx; nx = ny; ny = tmp;
		tmp = ux; ux = uy; uy = tmp;
	}
	if(nx == 0) return i_pat; /* _Ȃ`܂B */

	/* ŏ̃p^[CfNXmɗL͈͓ɂ܂B */
	i_pat %= n_pat;

	/* DDA[vB */
	d = -nx;
	n = nx + clipped; /* I_NbvꂽAI_`B */
	do {
		color = pat[i_pat++];
		if(i_pat == n_pat) i_pat = 0;
		if(color < 4) *vptr = color;
		vptr += ux;
		d += ny * 2;
		if(d >= 0) {
			vptr += uy;
			d -= nx * 2;
		}
	} while(--n); /* I_͕`Ȃ̂ŁAvfNgłB   */
		      /* I_NbvꂽAI_`܂A */
		      /* ̏ꍇ́A[vOɗ\+1Ă̂ŁA */
		      /* ɂ悱ł̓vfNgłB   */

	return i_pat;

#undef CLIP
}

void
render_rectangle(RENDER* render, int x, int y, int w, int h, int color)
{
	int x0, y0, x1, y1;

	/* TCY0x0Ȃ牽܂B */
	if(w == 0 || h == 0) return;

	/* K܂B(`Ě`) */
	if(w < 0) { x += w; w = -w; }
	if(h < 0) { y += h; h = -h; }

	/* _̏ꍇ̂݁Arender_line()ł͕`Ȃ̂ŁAʏłB */
	if(w == 1 && h == 1) {
		render_point(render, x, y, color);
		return;
	}

	/* ``܂B
	 * * ݂̎͊ȒP̂߂render_line()gĂ܂A
	 *   E`Ȃ̂ŁAƍ\łB
	 */
	x0 = x;
	y0 = y;
	x1 = x + w - 1;
	y1 = y + h - 1;
	render_line(render, x0, y0, x1, y0, color); /* `E */
	render_line(render, x1, y0, x1, y1, color); /* E`E */
	render_line(render, x1, y1, x0, y1, color); /* E` */
	render_line(render, x0, y1, x0, y0, color); /* ` */
}

void
render_rectangle_fill(RENDER* render, int x, int y, int w, int h, int color)
{
	SURFACE* surface;
	unsigned char* p;
	int i, n;

	/* T[tFCXoĂ܂B */
	surface = render->surface;

	/* K܂B(`Ě`) */
	if(w < 0) { x += w; w = -w; }
	if(h < 0) { y += h; h = -h; }

	/* NbsO܂B */
	if(x < render->left) {
		n = render->left - x; /* ɂ͂ݏosNZ */
		x = render->left;
		w -= n;
	}
	if(x + w > render->right) {
		w = render->right - x;
	}
	if(w <= 0) return; /* ʊO */
	if(y < render->top) {
		n = render->top - y; /* ɂ͂ݏosNZ */
		y = render->top;
		h -= n;
	}
	if(y + h > render->bottom) {
		h = render->bottom - y;
	}
	if(h <= 0) return; /* ʊO */

	/* hԂ܂B */
	for(i = 0, p = &surface->vbuff[surface->w * y + x]; i < h; i++, p += surface->w) {
		memset(p, color, w);
	}
}

/* * |S`͑SĐŏł܂A݂̎ł͂ȂĂ܂B
 *   bV`̃R[h𗬗p߁ANbsOɕgĂ܂B2003/03/25 Œ菬ɂȂ܂
 *   ̕Ǝ̐ɏ΁A啝ɍł͂łB(TODO)
 * * Ǝv܂ANbsỎǂł́A3%xȂȂ悤łB
 *   |S`ł͂yRyAsvȂ̂ŁAȗ25%xȂ܂B
 *   ̂߂ɁAyRyÃXLC`ǉ̂ǂłB
 * * ->Ă݂܂B
 */
void
render_polygon(RENDER* render, const VERTEX* vertices, int n_vertices, int color)
{
	int i;
	const VERTEX* vertex;
	CLIPVERTEX *clip_vertex;
	RENDVERTEX *rend_vertex;

	/* NbsOp_XggݗĂ܂B */
	if(n_vertices > N_VERTICES_MAX) n_vertices = N_VERTICES_MAX;
	for(i = 0, vertex = vertices, clip_vertex = render_work->clip_vertices[0];
	    i < n_vertices;
	    i++, vertex++, clip_vertex++) {
		clip_vertex->x = fild(vertex->x);
		clip_vertex->y = fild(vertex->y);
		clip_vertex->z = fild(1); /* ʃNbsÔ߂̃_~[B0ȊOȂ牽łOKłB */
		clip_vertex->s = fadd(fild(vertex->s), fld(0.5)); /* eNZ̒S|Cg */
		clip_vertex->t = fadd(fild(vertex->t), fld(0.5)); /* eNZ̒S|Cg */
	}
	if(n_vertices < 3) return;

	/* ʃNbsOs܂B */
	n_vertices = clip_xy(render, n_vertices);
	if(n_vertices < 3) return;

	/* `p_XggݗĂ܂B */
	for(i = 0, clip_vertex = render_work->clip_vertices[0], rend_vertex = render_work->rend_vertices;
	    i < n_vertices;
	    i++, clip_vertex++, rend_vertex++) {
		rend_vertex->x = fist(clip_vertex->x);
		rend_vertex->y = fist(clip_vertex->y);
		/* draw_primitive_woz()rend_vertex->zgȂ̂ŁAsl̂܂܂ővłB */
		rend_vertex->s = fist(fimul(clip_vertex->s, 1 << 8)); /* 8.8bit */
		rend_vertex->t = fist(fimul(clip_vertex->t, 1 << 8)); /* 8.8bit */
	}

	/* v~eBu`܂B */
	draw_primitive_woz(render, n_vertices, color);
}

void
render_mesh(RENDER* render, const MESH* mesh)
{
	int i, j, n_vectors, n_tcoords, n_faces, n_face_vertices, n_vertices;
	fixed s, xN0, yN0, x01, y01;
	struct _vector *vectors, *vector, *vector_src, *vector_dst; /* ϐvectorƂ̏Փˉ̂߁A\̖ɂstruct_vectorgp */
	TCOORD *tcoords, *tcoord;
	FACE *face;
	FACEVERTEX *face_vertices, *face_vertex;
	CLIPVERTEX *clip_vertex;
	RENDVERTEX *rend_vertex;

	/* Xg̐擪AhXvZ܂B */
	n_vectors = mesh->nv;
	n_tcoords = mesh->nc;
	n_faces = mesh->nf;
	vectors = (struct _vector*)(mesh + 1); /* ϐvectorƂ̏Փˉ̂߁A\̖ɂstruct_vectorgp */
	tcoords = (TCOORD*)(vectors + n_vectors);
	face = (FACE*)(tcoords + n_tcoords);

	/* S_Wϊ܂B */
	for(i = 0, vector_src = vectors, vector_dst = render_work->xformed_vectors;
	    i < n_vectors;
	    i++, vector_src++, vector_dst++) {
		*vector_dst = vxform(render->context->matrix, *vector_src);
	}

	/* etFCX`܂B */
	for(i = 0;
	    i < n_faces;
	    i++, face = (FACE*)(face_vertices + n_face_vertices)) {
		n_face_vertices = face->nfv;
		face_vertices = (FACEVERTEX*)(face + 1);

		/* NbsOp_XggݗĂ܂B
		 * * eNX`̏ꍇsĂ܂񂪁AɖȂ͂łB
		 *   eNX`Ȃmesh->nc=0Ȃ̂ŁAtcoords͍ŏ̃tFCXwĂ܂B
		 *   etFCX_face_vertex->ic=0Ȃ̂ŁAeNX`WƂčŏ̃tFCXm,n擾܂B
		 *   mesh->nf=0̏ꍇ̂ݍŏ̃tFCX݂܂񂪁Ȁꍇ͂̃[v̂܂B
		 *   擾eNX`W͕`掞ɖ̂ŁAeNX`Wl͊֌W܂B
		 *   L̒ʂAeNX`W擾ɕsȃ̈ɃANZXȂƂۏ؂܂B
		 *   ]āAeNX`̏ꍇsȂĂAɖ͂ȂƎv܂B
		 */
		n_vertices = 0;
		for(j = 0, face_vertex = face_vertices, clip_vertex = render_work->clip_vertices[0];
		    j < n_face_vertices;
		    j++, face_vertex++, clip_vertex++) {
			vector = &render_work->xformed_vectors[face_vertex->iv];
			tcoord = &tcoords[face_vertex->ic];
			clip_vertex->x = vector->x;
			clip_vertex->y = vector->y;
			clip_vertex->z = vector->z;
			clip_vertex->s = fadd(fild(tcoord->s), fld(0.5)); /* eNZ̒S|Cg */
			clip_vertex->t = fadd(fild(tcoord->t), fld(0.5)); /* eNZ̒S|Cg */
			if(++n_vertices == N_VERTICES_MAX) break;
		}
		if(n_vertices < 3) continue;

		/* yNbsOs܂B */
		n_vertices = clip_z(render, n_vertices);
		if(n_vertices < 3) continue;

		/* ϊ̂߂ x=x/z,y=y/z s܂B */
		for(j = 0, clip_vertex = render_work->clip_vertices[0];
		    j < n_vertices;
		    j++, clip_vertex++) {
			clip_vertex->x = fdiv(clip_vertex->x, clip_vertex->z);
			clip_vertex->y = fdiv(clip_vertex->y, clip_vertex->z);
		}

		/* \s܂B
		 * E(=\)LqȂ̂ŁA(=)Ȃ`܂B
		 */
		xN0 = fsub(render_work->clip_vertices[0][0].x, render_work->clip_vertices[0][n_vertices - 1].x);
		yN0 = fsub(render_work->clip_vertices[0][0].y, render_work->clip_vertices[0][n_vertices - 1].y);
		x01 = fsub(render_work->clip_vertices[0][1].x, render_work->clip_vertices[0][             0].x);
		y01 = fsub(render_work->clip_vertices[0][1].y, render_work->clip_vertices[0][             0].y);
		s = fsub(fmul(xN0, y01), fmul(x01, yN0));
		if(fcom(s, fld(0)) <= 0) continue;

		/* ʃNbsOs܂B */
		n_vertices = clip_xy(render, n_vertices);
		if(n_vertices < 3) continue;

		/* `p_XggݗĂ܂B */
		for(j = 0, clip_vertex = render_work->clip_vertices[0], rend_vertex = render_work->rend_vertices;
		    j < n_vertices;
		    j++, clip_vertex++, rend_vertex++) {
			rend_vertex->x = fist(clip_vertex->x);
			rend_vertex->y = fist(clip_vertex->y);
			rend_vertex->z = fist(fimul(fdiv(fmul(fsub(clip_vertex->z, render->front), render->back  ),
							 fmul(fsub(render->back  , render->front), clip_vertex->z)), 0xffff)); /* 8.8bit */
			rend_vertex->s = fist(fimul(clip_vertex->s, 1 << 8)); /* 8.8bit */
			rend_vertex->t = fist(fimul(clip_vertex->t, 1 << 8)); /* 8.8bit */
		}

		/* v~eBu`܂B */
		draw_primitive_wz(render, n_vertices, face->c);
	}
}

/* yNbsOs܂B
 * [in]
 *	render				_[ւ̃|C^B
 *	nsrc				NbsO钸_̐B
 *	render_work->clip_vertices[0]	NbsO钸_XgB(O[oϐ)
 * [out]
 *	߂l				NbsO̒_̐B
 *	render_work->clip_vertices[0]	NbsO̒_XgB(O[oϐ)
 * [note]
 *	* Ɨ̈ƂāArender_work->clip_vertices[1]g܂B
 */
static int
clip_z(RENDER* render, int nsrc)
{
#define CLIP(SRC, DST, OP, LIM) \
	src = SRC; \
	dst = DST; \
	ndst = 0; \
	lim = LIM; \
	for(i = 0; i < nsrc; i++) { \
		v0 = src +  i; \
		v1 = src + (i + 1) % nsrc; \
		if(fcom(v0->z, lim) OP 0) { \
			*dst = *v0; \
			dst++; \
			ndst++; \
			if(ndst == N_VERTICES_MAX) break; \
			if(fcom(v1->z, lim) OP 0) { \
				continue; \
			} else { \
				/* go clip */ \
			} \
		} else { \
			if(fcom(v1->z, lim) OP 0) { \
				/* go clip */ \
			} else { \
				continue; \
			} \
		} \
		/* do clip */ \
		dst->z = lim; \
		n0 = fsub(lim, v0->z); \
		n1 = fsub(v1->z, lim); \
		n01 = fadd(n0, n1); \
		n001 = fdiv(n0, n01); \
		dst->x = fadd(v0->x, fmul(fsub(v1->x, v0->x), n001)); \
		dst->y = fadd(v0->y, fmul(fsub(v1->y, v0->y), n001)); \
		dst->s = fadd(v0->s, fmul(fsub(v1->s, v0->s), n001)); \
		dst->t = fadd(v0->t, fmul(fsub(v1->t, v0->t), n001)); \
		dst++; \
		ndst++; \
		if(ndst == N_VERTICES_MAX) break; \
	} \
	if(ndst < 3) return 0; \

	CLIPVERTEX *src, *dst;
	CLIPVERTEX *v0, *v1;
	fixed lim, n0, n1, n01, n001;
	int i, ndst;

	CLIP(render_work->clip_vertices[0], render_work->clip_vertices[1], >=, render->front); nsrc = ndst;
	CLIP(render_work->clip_vertices[1], render_work->clip_vertices[0], <=, render->back );
	return ndst;

#undef CLIP
}

/* ʃNbsOs܂B
 * [in]
 *	render				_[ւ̃|C^B
 *	nsrc				NbsO钸_̐B
 *	render_work->clip_vertices[0]	NbsO钸_XgB(O[oϐ)
 * [out]
 *	߂l				NbsO̒_̐B
 *	render_work->clip_vertices[0]	NbsO̒_XgB(O[oϐ)
 * [note]
 *	* Ɨ̈ƂāArender_work->clip_vertices[1]g܂B
 */
static int
clip_xy(RENDER* render, int nsrc)
{
#define CLIP(SRC, DST, X, Y, OP, LIM) \
	src = SRC; \
	dst = DST; \
	ndst = 0; \
	lim = LIM; \
	for(i = 0; i < nsrc; i++) { \
		v0 = src +  i; \
		v1 = src + (i + 1) % nsrc; \
		if(fcom(v0->X, lim) OP 0) { \
			*dst = *v0; \
			dst++; \
			ndst++; \
			if(ndst == N_VERTICES_MAX) break; \
			if(fcom(v1->X, lim) OP 0) { \
				continue; \
			} else { \
				/* go clip */ \
			} \
		} else { \
			if(fcom(v1->X, lim) OP 0) { \
				/* go clip */ \
			} else { \
				continue; \
			} \
		} \
		/* do clip */ \
		dst->X = lim; \
		n0 = fsub(lim, v0->X); \
		n1 = fsub(v1->X, lim); \
		n01 = fadd(n0, n1); \
		n001 = fdiv(n0, n01); \
		dst->Y = fadd(v0->Y, fmul(fsub(v1->Y, v0->Y), n001)); \
		n0 = fmul(n0, v0->z); \
		n1 = fmul(n1, v1->z); \
		n01 = fadd(n0, n1); \
		n001 = fdiv(n0, n01); \
		dst->z = fadd(v0->z, fmul(fsub(v1->z, v0->z), n001)); \
		dst->s = fadd(v0->s, fmul(fsub(v1->s, v0->s), n001)); \
		dst->t = fadd(v0->t, fmul(fsub(v1->t, v0->t), n001)); \
		dst++; \
		ndst++; \
		if(ndst == N_VERTICES_MAX) break; \
	} \
	if(ndst < 3) return 0; \

	CLIPVERTEX *src, *dst;
	CLIPVERTEX *v0, *v1;
	fixed lim, n0, n1, n01, n001;
	int i, ndst;

	CLIP(render_work->clip_vertices[0], render_work->clip_vertices[1], x, y, >=, fild(render->left  )); nsrc = ndst;
	CLIP(render_work->clip_vertices[1], render_work->clip_vertices[0], x, y, <=, fild(render->right )); nsrc = ndst;
	CLIP(render_work->clip_vertices[0], render_work->clip_vertices[1], y, x, >=, fild(render->top   )); nsrc = ndst;
	CLIP(render_work->clip_vertices[1], render_work->clip_vertices[0], y, x, <=, fild(render->bottom));
	return ndst;

#undef CLIP
}

/****************************************************************************
 *	XLC`֐p}N`
 ****************************************************************************/

/* draw_primitive_*()p DDAZbgAbv */
#define SETUP1(i) \
	side->cur.i = v0->i; \
	if(v0->i <= v1->i) { \
		side->i.n = (v1->i - v0->i) % side->ny; \
		side->i.d = -side->ny; \
		side->i.u = (v1->i - v0->i) / side->ny; \
		side->i.v = 1; \
	} else { \
		side->i.n = (v0->i - v1->i) % side->ny; \
		side->i.d = -side->ny; \
		side->i.u = -((v0->i - v1->i) / side->ny); \
		side->i.v = -1; \
	}

/* draw_primitive_*()p DDAXebvs */
#define STEP1(i) \
	side->cur.i += side->i.u; \
	side->i.d += side->i.n * 2; \
	if(side->i.d >= 0) { \
		side->cur.i += side->i.v; \
		side->i.d -= side->ny * 2; \
	}

/* draw_scanline_*_*()p DDAZbgAbv */
#define SETUP2(i) \
	cur.i = v0->i; \
	if(v0->i <= v1->i) { \
		i.n = (v1->i - v0->i) % nx; \
		i.d = -nx; \
		i.u = (v1->i - v0->i) / nx; \
		i.v = 1; \
	} else { \
		i.n = (v0->i - v1->i) % nx; \
		i.d = -nx; \
		i.u = -((v0->i - v1->i) / nx); \
		i.v = -1; \
	}

/* draw_scanline_*_*()p DDAXebvs */
#define STEP2(i) \
	cur.i += i.u; \
	i.d += i.n * 2; \
	if(i.d >= 0) { \
		cur.i += i.v; \
		i.d -= nx * 2; \
	}

/****************************************************************************
 *	yRyA
 ****************************************************************************/

/* v~eBu`܂B
 * [in]
 *	render				_[ւ̃|C^B
 *	n_vertices			_̐B
 *	render_work->rend_vertices	_XgB(O[oϐ)
 *	color				J[B
 */
static void
draw_primitive_wz(RENDER* render, int n_vertices, int color)
{
	struct {
		int iv;		/* ݂̕ӂ̏I_CfNX            */
		int ny;		/* ݂̕ӂ̍̕ψ                */
		int n;		/* ݂̕ӂ̎c胉C              */
		RENDVERTEX cur;	/* ݒl                              */
		DDA x, z;	/* _WDDA(y͍Eʂ1Âi) */
		DDA s, t;	/* eNX`WDDA                   */
	} sides[2], *side;

	DSLPARAM param;
	int i, itop, y, top, bottom;
	DSLPROC draw_scanline;
	RENDVERTEX *v, *v0, *v1;

	/* XLC`p[^܂B */
	draw_scanline = select_draw_scanline_wz(&param, render, color);

	/* ㉺[̈ʒuƁA[̒_߂܂B */
	itop = 0;
	top = bottom = render_work->rend_vertices[0].y;
	for(i = 1; i < n_vertices; i++) {
		v = &render_work->rend_vertices[i];
		if(v->y < top) {
			itop = i;
			top = v->y;
		}
		if(v->y > bottom) {
			bottom = v->y;
		}
	}
	if(top == bottom) return; /* |S͕`܂B */

	/* E̕ӂ܂B */
	for(i = 0; i < 2; i++) {
		side = &sides[i];
		side->iv = itop;
		side->n = 0; /* ɖ{̏s悤 */
	}

	/* [AeXLCɂ... */
	for(y = top; y < bottom; y++) {
		/* E̕ӂɂ... */
		for(i = 0; i < 2; i++) {
			side = &sides[i];
			/* ̕ӂɒB... */
			if(side->n == 0) {
				do {
					/* ̕ӂ̗[̒_߂܂B */
					v0 = &render_work->rend_vertices[side->iv];
					if(i == 0) {
						side->iv--;
						if(side->iv == -1) {
							side->iv = n_vertices - 1;
						}
					} else {
						side->iv++;
						if(side->iv == n_vertices) {
							side->iv = 0;
						}
					}
					v1 = &render_work->rend_vertices[side->iv];
					/* ̕ӂ̍̕ψʂ߂܂B */
					side->ny = v1->y - v0->y;
					/* V|SoAc̕`̓LZ܂B */
					if(side->ny < 0) return;
				} while(side->ny == 0); /* ȕӂ͖܂B */
				/* DDAZbgAbvB */
				SETUP1(x);
				SETUP1(z);
				SETUP1(s);
				SETUP1(t);
				/* ̕ӂ܂ł̃JE^B */
				side->n = side->ny;
			}
		}
		/* E̕ӂ̊ԂɁA`܂B */
		sides[0].cur.y = sides[1].cur.y = y;
		draw_scanline(&sides[0].cur, &sides[1].cur, &param);
		/* E̕ӂɂ... */
		for(i = 0; i < 2; i++) {
			side = &sides[i];
			/* ̕ӂ܂ł̃C炵܂B */
			side->n--;
			/* DDAXebvsB */
			STEP1(x)
			STEP1(z)
			STEP1(s)
			STEP1(t)
		}
	}
	/* [̃XLC͕`܂B */
}

/* XLC`p[^܂B
 * [in]
 *	param		p[^\̂ւ̃|C^B
 *	render		_[ւ̃|C^B
 * [out]
 *	߂l		XLC`֐ւ̃|C^B
 * [note]
 *	* gȂo͏܂Bi[NA܂j
 */
static DSLPROC
select_draw_scanline_wz(DSLPARAM* param, RENDER* render, int color)
{
	SURFACE* surface = render->surface;
	TEXTURE* texture = render->context->texture;
	DSLPROC draw_scanline;

	/* T[tFCX */
	param->surface_w     = surface->w;
	param->surface_h     = surface->h;
	param->surface_vbuff = surface->vbuff;
	param->surface_zbuff = surface->zbuff;

	/* eNX`EJ[ */
	if(texture == NULL) {
		//param->texture_w    = gȂ
		//param->texture_h    = gȂ
		//param->texture_buf  = gȂ
		//param->texture_mask = gȂ
		param->back_color     = color & 15;
		//param->fore_color   = gȂ
		draw_scanline = draw_scanline_wz_color;
	} else {
		param->texture_w   = texture->header.w;
		param->texture_h   = texture->header.h;
		param->texture_buf = texture->buf;
		switch(texture->header.bpp) {
		case 1:
			if(!texture->header.mask) {
				//param->texture_mask = gȂ
				draw_scanline = draw_scanline_wz_1bit;
			} else {
				param->texture_mask = texture->mask;
				draw_scanline = draw_scanline_wz_1bitmask;
			}
			param->back_color = color      & 15;
			param->fore_color = color >> 4 & 15;
			break;
		default/*2*/:
			if(!texture->header.mask) {
				//param->texture_mask = gȂ
				draw_scanline = draw_scanline_wz_2bit;
			} else {
				param->texture_mask = texture->mask;
				draw_scanline = draw_scanline_wz_2bitmask;
			}
			//param->back_color = gȂ
			//param->fore_color = gȂ
			break;
		}
	}

	return draw_scanline;
}

#ifdef NOASM
/*static*/ void
draw_scanline_wz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(z);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* eNX`ȂAtFCX̔wiFŕ`܂B */
			*vptr = param->back_color;
			*zptr = zval;
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		STEP2(z);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}
#else /*NOASM*/
#if 0
//	asm("
//	.align 1
//	.global draw_scanline_wz_color
//	;// IN:
//	;// %r12     = v0
//	;// %r13     = v1
//	;// %r14     = param
//draw_scanline_wz_color:
//	;// USAGE:
//	;// %r0      = cur.z
//	;// %r1      = cur.s (gȂ)
//	;// %r2      = cur.t (gȂ)
//	;// [%sp+ 0] = DDA.z
//	;// [%sp+16] = DDA.s (gȂ)
//	;// [%sp+32] = DDA.t (gȂ)
//	pushn %r2
//	xsub %sp, %sp, 48
//
//	;// m :v0 -> v1:E Ƃ܂B
//	xld.uh %r4, [%r12+0]	;// v0->x
//	xld.uh %r5, [%r13+0]	;// v1->x
//	cmp %r4, %r5
//	xjrule __draw_scanline_wz_color_swap
//	xor %r12, %r13
//	xor %r13, %r12
//	xor %r12, %r13
//__draw_scanline_wz_color_swap:
//	;// %r12 = v0
//	;// %r13 = v1
//
//	;// n_AhX߂܂B
//	xld.uh %r4, [%r14+0]	;// param->surface_w
//	xld.uh %r5, [%r12+2]	;// v0->y
//	mltu.h %r4, %r5
//	ld.w %r4, %alr
//	xld.uh %r5, [%r12+0]	;// v0->x
//	add %r4, %r5
//	xld.w %r10, [%r14+4]	;// param->surface_vbuff
//	add %r10, %r4
//	xld.w %r11, [%r14+8]	;// param->surface_zbuff
//	add %r11, %r4
//	;// %r10 = vptr
//	;// %r11 = zptr
//	;// %r5  = v0->x
//
//	;// 厲DDAZbgAbvB
//	xld.uh %r15, [%r13+0]	;// v1->x
//	sub %r15, %r5
//	xjreq __draw_scanline_wz_color_ret
//	;// %r15 = nx
//
//	;// DDAZbgAbvB
//	;// (DDA.z)
//	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
//	xld.uh %r4, [%r13+4]	;// v1->z
//	sub %r4, %r0
//	xld.w %r5, 1
//	xjruge __draw_scanline_wz_color_setup_z
//	not %r4, %r4
//	xadd %r4, %r4, 1
//	xld.w %r5, -1
//__draw_scanline_wz_color_setup_z:
//	xsll %r4, 16
//	ld.w %alr, %r4
//	div0u %r15
//	div1 %r15		;//  1
//	div1 %r15		;//  2
//	div1 %r15		;//  3
//	div1 %r15		;//  4
//	div1 %r15		;//  5
//	div1 %r15		;//  6
//	div1 %r15		;//  7
//	div1 %r15		;//  8
//	div1 %r15		;//  9
//	div1 %r15		;// 10
//	div1 %r15		;// 11
//	div1 %r15		;// 12
//	div1 %r15		;// 13
//	div1 %r15		;// 14
//	div1 %r15		;// 15
//	div1 %r15		;// 16
//	ld.w %r4, %ahr
//	add %r4, %r4
//	xld.w [%sp+ 0], %r4	;// z.n * 2
//	not %r4, %r15
//	xadd %r4, %r4, 1
//	xld.w [%sp+ 4], %r4	;// z.d
//	ld.w %r4, %alr
//	mlt.h %r4, %r5
//	ld.w %r4, %alr
//	xld.w [%sp+ 8], %r4	;// z.u
//	xld.w [%sp+12], %r5	;// z.v
//	;// %r0      = cur.z
//	;// [%sp+ 0] = z.n * 2
//	;// [%sp+ 4] = z.d
//	;// [%sp+ 8] = z.u
//	;// [%sp+12] = z.v
//
//	;// DDA[vB
//	ld.w %r7, %r15
//	add %r15, %r15
//	xld.ub %r12, [%r14+24]	;// param->back_color
//__draw_scanline_wz_color_loop:
//	;// %r7  = n
//	;// %r15 = nx * 2
//	;// %r12 = back_color
//
//	;// yrB
//	ld.uh %r4, %r0		;// zval
//	xsrl %r4, 8
//	xld.ub %r5, [%r11]	;// *zptr
//	cmp %r4, %r5
//	xjrugt __draw_scanline_wz_color_skip
//	;// %r4 = zval
//
//	;// eNX`ȂAtFCX̔wiFŕ`܂B
//	xld.b [%r10], %r12	;// *vptr
//	xld.b [%r11], %r4	;// *zptr
//__draw_scanline_wz_color_skip:
//
//	;// obt@|C^i߂܂B
//	xadd %r10, %r10, 1
//	xadd %r11, %r11, 1
//
//	;// DDAXebvsB
//	;// (DDA.z)
//	xld.w %r4, [%sp+ 8]	;// z.u
//	add %r0, %r4
//	xld.w %r4, [%sp+ 4]	;// z.d
//	xld.w %r5, [%sp+ 0]	;// z.n * 2
//	add %r4, %r5
//	xjruge __draw_scanline_wz_color_step_z ;// !C
//	xld.w %r5, [%sp+12]	;// z.v
//	add %r0, %r5
//	sub %r4, %r15
//__draw_scanline_wz_color_step_z:
//	xld.w [%sp+ 4], %r4	;// z.d
//
//	xsub %r7, %r7, 1
//	xjrne __draw_scanline_wz_color_loop
//
//__draw_scanline_wz_color_ret:
//	xadd	%sp, %sp, 48
//	popn	%r2
//	ret
//	");
#else	/* draw_scanline_wz_2bitmaskƓWX^蓖ẮAWIȎ */
	/* ]WX^Ƀ[N蓖ĂŁBWł30%x */
	asm("
	.align 1
	.global draw_scanline_wz_color
	;// IN:
	;// %r12     = v0
	;// %r13     = v1
	;// %r14     = param
draw_scanline_wz_color:
	;// USAGE:
	;// %r0  = cur.z
	;// %r1  = DDA.z.n * 2
	;// %r2  = DDA.z.d
	;// %r6  = DDA.z.u
	;// %r13 = DDA.z.v
	pushn %r2

	;// m :v0 -> v1:E Ƃ܂B
	xld.uh %r4, [%r12+0]	;// v0->x
	xld.uh %r5, [%r13+0]	;// v1->x
	cmp %r4, %r5
	xjrule __draw_scanline_wz_color_swap
	xor %r12, %r13
	xor %r13, %r12
	xor %r12, %r13
__draw_scanline_wz_color_swap:
	;// %r12 = v0
	;// %r13 = v1

	;// n_AhX߂܂B
	xld.uh %r4, [%r14+0]	;// param->surface_w
	xld.uh %r5, [%r12+2]	;// v0->y
	mltu.h %r4, %r5
	ld.w %r4, %alr
	xld.uh %r5, [%r12+0]	;// v0->x
	add %r4, %r5
	xld.w %r10, [%r14+4]	;// param->surface_vbuff
	add %r10, %r4
	xld.w %r11, [%r14+8]	;// param->surface_zbuff
	add %r11, %r4
	;// %r10 = vptr
	;// %r11 = zptr
	;// %r5  = v0->x

	;// 厲DDAZbgAbvB
	xld.uh %r15, [%r13+0]	;// v1->x
	sub %r15, %r5
	xjreq __draw_scanline_wz_color_ret
	;// %r15 = nx

	;// DDAZbgAbvB
	;// (DDA.z)
	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
	xld.uh %r4, [%r13+4]	;// v1->z
	sub %r4, %r0
	xld.w %r13, 1		;// z.v
	xjruge __draw_scanline_wz_color_setup_z
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r13, -1		;// z.v
__draw_scanline_wz_color_setup_z:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r1, %ahr		;// z.n * 2
	add %r1, %r1
	not %r2, %r15		;// z.d
	xadd %r2, %r2, 1
	ld.w %r6, %alr		;// z.u
	mlt.h %r6, %r13
	ld.w %r6, %alr
	;// %r0  = cur.z
	;// %r1  = DDA.z.n * 2
	;// %r2  = DDA.z.d
	;// %r6  = DDA.z.u
	;// %r13 = DDA.z.v

	;// DDA[vB
	ld.w %r7, %r15
	add %r15, %r15
	xld.ub %r12, [%r14+24]	;// param->back_color
__draw_scanline_wz_color_loop:
	;// %r7  = n
	;// %r15 = nx * 2
	;// %r12 = back_color

	;// yrB
	ld.uh %r4, %r0		;// zval
	xsrl %r4, 8
	xld.ub %r5, [%r11]	;// *zptr
	cmp %r4, %r5
	xjrugt __draw_scanline_wz_color_skip
	;// %r4 = zval

	;// eNX`ȂAtFCX̔wiFŕ`܂B
	xld.b [%r10], %r12	;// *vptr
	xld.b [%r11], %r4	;// *zptr
__draw_scanline_wz_color_skip:

	;// obt@|C^i߂܂B
	xadd %r10, %r10, 1
	xadd %r11, %r11, 1

	;// DDAXebvsB
	;// (DDA.z)
	add %r0, %r6		;// cur.z += z.u
	add %r2, %r1		;// z.d += z.n * 2
	xjruge __draw_scanline_wz_color_step_z ;// !C
	add %r0, %r13		;// cur.z += z.v
	sub %r2, %r15		;// z.d -= nx * 2
__draw_scanline_wz_color_step_z:

	xsub %r7, %r7, 1
	xjrne __draw_scanline_wz_color_loop

__draw_scanline_wz_color_ret:
	popn	%r2
	ret
	");
#endif
#endif /*NOASM*/

/*static*/ void
draw_scanline_wz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(z);
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
			 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
			 * R[hTCYƂ̌ˍŁÂőË܂B
			 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
			 */
			sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
			tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
			ofs = param->texture_w * tval + sval;
			/* 1biteNX`ȂAeNZlɂ 1:tFCX̑OiF/0:tFCX̔wiF ŕ`܂B */
			*vptr = param->texture_buf[ofs / 8] >> (7 - (ofs & 7)) & 1 ? param->fore_color : param->back_color;
			*zptr = zval;
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		STEP2(z);
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

/*static*/ void
draw_scanline_wz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(z);
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
			 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
			 * R[hTCYƂ̌ˍŁÂőË܂B
			 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
			 */
			sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
			tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
			ofs = param->texture_w * tval + sval;
			if(param->texture_mask[ofs / 8] >> (7 - (ofs & 7)) & 1) {
				/* 1biteNX`ȂAeNZlɂ 1:tFCX̑OiF/0:tFCX̔wiF ŕ`܂B */
				*vptr = param->texture_buf[ofs / 8] >> (7 - (ofs & 7)) & 1 ? param->fore_color : param->back_color;
				*zptr = zval;
			}
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		STEP2(z);
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

#ifdef NOASM
/*static*/ void
draw_scanline_wz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(z);
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
			 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
			 * R[hTCYƂ̌ˍŁÂőË܂B
			 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
			 */
			sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
			tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
			ofs = param->texture_w * tval + sval;
			/* 2biteNX`ȂAeNZl̂܂ܕ`܂B */
			*vptr = param->texture_buf[ofs / 4] >> (3 - (ofs & 3)) * 2 & 3;
			*zptr = zval;
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		STEP2(z);
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}
#else /*NOASM*/
	asm("
	.align 1
	.global draw_scanline_wz_2bit
	;// IN:
	;// %r12     = v0
	;// %r13     = v1
	;// %r14     = param
draw_scanline_wz_2bit:
	;// USAGE:
	;// %r0      = cur.z
	;// %r1      = cur.s
	;// %r2      = cur.t
	;// [%sp+ 0] = DDA.z
	;// [%sp+16] = DDA.s
	;// [%sp+32] = DDA.t
	pushn %r2
	xsub %sp, %sp, 48

	;// m :v0 -> v1:E Ƃ܂B
	xld.uh %r4, [%r12+0]	;// v0->x
	xld.uh %r5, [%r13+0]	;// v1->x
	cmp %r4, %r5
	xjrule __draw_scanline_wz_2bit_swap
	xor %r12, %r13
	xor %r13, %r12
	xor %r12, %r13
__draw_scanline_wz_2bit_swap:
	;// %r12 = v0
	;// %r13 = v1

	;// n_AhX߂܂B
	xld.uh %r4, [%r14+0]	;// param->surface_w
	xld.uh %r5, [%r12+2]	;// v0->y
	mltu.h %r4, %r5
	ld.w %r4, %alr
	xld.uh %r5, [%r12+0]	;// v0->x
	add %r4, %r5
	xld.w %r10, [%r14+4]	;// param->surface_vbuff
	add %r10, %r4
	xld.w %r11, [%r14+8]	;// param->surface_zbuff
	add %r11, %r4
	;// %r10 = vptr
	;// %r11 = zptr
	;// %r5  = v0->x

	;// 厲DDAZbgAbvB
	xld.uh %r15, [%r13+0]	;// v1->x
	sub %r15, %r5
	xjreq __draw_scanline_wz_2bit_ret
	;// %r15 = nx

	;// DDAZbgAbvB
	;// (DDA.z)
	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
	xld.uh %r4, [%r13+4]	;// v1->z
	sub %r4, %r0
	xld.w %r5, 1
	xjruge __draw_scanline_wz_2bit_setup_z
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r5, -1
__draw_scanline_wz_2bit_setup_z:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r4, %ahr
	add %r4, %r4
	xld.w [%sp+ 0], %r4	;// z.n * 2
	not %r4, %r15
	xadd %r4, %r4, 1
	xld.w [%sp+ 4], %r4	;// z.d
	ld.w %r4, %alr
	mlt.h %r4, %r5
	ld.w %r4, %alr
	xld.w [%sp+ 8], %r4	;// z.u
	xld.w [%sp+12], %r5	;// z.v
	;// %r0      = cur.z
	;// [%sp+ 0] = z.n * 2
	;// [%sp+ 4] = z.d
	;// [%sp+ 8] = z.u
	;// [%sp+12] = z.v
	;
	;// (DDA.s)
	xld.uh %r1, [%r12+6]	;// v0->s => cur.s
	xld.uh %r4, [%r13+6]	;// v1->s
	sub %r4, %r1
	xld.w %r5, 1
	xjruge __draw_scanline_wz_2bit_setup_s
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r5, -1
__draw_scanline_wz_2bit_setup_s:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r4, %ahr
	add %r4, %r4
	xld.w [%sp+16], %r4	;// s.n * 2
	not %r4, %r15
	xadd %r4, %r4, 1
	xld.w [%sp+20], %r4	;// s.d
	ld.w %r4, %alr
	mlt.h %r4, %r5
	ld.w %r4, %alr
	xld.w [%sp+24], %r4	;// s.u
	xld.w [%sp+28], %r5	;// s.v
	;// %r1      = cur.s
	;// [%sp+16] = s.n * 2
	;// [%sp+20] = s.d
	;// [%sp+24] = s.u
	;// [%sp+28] = s.v
	;
	;// (DDA.t)
	xld.uh %r2, [%r12+8]	;// v0->t => cur.t
	xld.uh %r4, [%r13+8]	;// v1->t
	sub %r4, %r2
	xld.w %r5, 1
	xjruge __draw_scanline_wz_2bit_setup_t
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r5, -1
__draw_scanline_wz_2bit_setup_t:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r4, %ahr
	add %r4, %r4
	xld.w [%sp+32], %r4	;// t.n * 2
	not %r4, %r15
	xadd %r4, %r4, 1
	xld.w [%sp+36], %r4	;// t.d
	ld.w %r4, %alr
	mlt.h %r4, %r5
	ld.w %r4, %alr
	xld.w [%sp+40], %r4	;// t.u
	xld.w [%sp+44], %r5	;// t.v
	;// %r2      = cur.t
	;// [%sp+32] = t.n * 2
	;// [%sp+36] = t.d
	;// [%sp+40] = t.u
	;// [%sp+44] = t.v

	;// DDA[vB
	ld.w %r7, %r15
	add %r15, %r15
__draw_scanline_wz_2bit_loop:
	;// %r7  = n
	;// %r15 = nx * 2

	;// yrB
	ld.uh %r4, %r0		;// zval
	xsrl %r4, 8
	xld.ub %r5, [%r11]	;// *zptr
	cmp %r4, %r5
	xjrugt __draw_scanline_wz_2bit_skip
	;// %r4 = zval

	;// eNX`ItZbgvZB
	ld.uh %r5, %r2		;// tval
	xsrl %r5, 8
	xld.uh %r12, [%r14+14]	;// param->texture_h
	cmp %r5, %r12
	xjrult __draw_scanline_wz_2bit_wrap_t
	xrr %r5, 8
	ld.w %alr, %r5
	div0u %r12
	div1 %r12		;// 1
	div1 %r12		;// 2
	div1 %r12		;// 3
	div1 %r12		;// 4
	div1 %r12		;// 5
	div1 %r12		;// 6
	div1 %r12		;// 7
	div1 %r12		;// 8
	ld.w %r5, %ahr
__draw_scanline_wz_2bit_wrap_t:
	;// %r5 = tval
	;
	ld.uh %r6, %r1		;// sval
	xsrl %r6, 8
	xld.uh %r12, [%r14+12]	;// param->texture_w
	cmp %r6, %r12
	xjrult __draw_scanline_wz_2bit_wrap_s
	xrr %r6, 8
	ld.w %alr, %r6
	div0u %r12
	div1 %r12		;// 1
	div1 %r12		;// 2
	div1 %r12		;// 3
	div1 %r12		;// 4
	div1 %r12		;// 5
	div1 %r12		;// 6
	div1 %r12		;// 7
	div1 %r12		;// 8
	ld.w %r6, %ahr
__draw_scanline_wz_2bit_wrap_s:
	;// %r6  = sval
	;// %r12 = texture_w
	;
	mltu.h %r5, %r12
	ld.w %r12, %alr
	add %r12, %r6
	;// %r12 = ofs

	;//{{draw_scanline_wz_2bitmaskƂ̈Ⴂ́A͈̔͂ƂłB
	;//;// }XNeXgB
	;//xld.w %r5, [%r14+20]	;// param->texture_mask
	;//ld.w %r6, %r12
	;//xsrl %r6, 3
	;//add %r5, %r6
	;//xld.ub %r5, [%r5]
	;//;
	;//not %r6, %r12
	;//xand %r6, %r6, 7
	;//srl %r5, %r6		;// %r6=0`7Ȃ̂xsrlɂKvȂBxsrlɂƗ]vȃR[hĒxȂB
	;//xand %r5, %r5, 1
	;//xjreq __draw_scanline_wz_2bit_skip
	;//}}draw_scanline_wz_2bitmaskƂ̈Ⴂ́A͈̔͂ƂłB

	;// 2biteNX`ȂAeNZl̂܂ܕ`܂B */
	xld.w %r5, [%r14+16]	;// param->texture_buf
	ld.w %r6, %r12
	xsrl %r6, 2
	add %r5, %r6
	xld.ub %r5, [%r5]
	;
	not %r6, %r12
	xand %r6, %r6, 3
	add %r6, %r6
	srl %r5, %r6		;// %r6={0|2|4|6}Ȃ̂xsrlɂKvȂBxsrlɂƗ]vȃR[hĒxȂB
	xand %r5, %r5, 3
	;
	xld.b [%r10], %r5	;// *vptr
	xld.b [%r11], %r4	;// *zptr
__draw_scanline_wz_2bit_skip:

	;// obt@|C^i߂܂B
	xadd %r10, %r10, 1
	xadd %r11, %r11, 1

	;// DDAXebvsB
	;// (DDA.z)
	xld.w %r4, [%sp+ 8]	;// z.u
	add %r0, %r4
	xld.w %r4, [%sp+ 4]	;// z.d
	xld.w %r5, [%sp+ 0]	;// z.n * 2
	add %r4, %r5
	xjruge __draw_scanline_wz_2bit_step_z ;// !C
	xld.w %r5, [%sp+12]	;// z.v
	add %r0, %r5
	sub %r4, %r15
__draw_scanline_wz_2bit_step_z:
	xld.w [%sp+ 4], %r4	;// z.d
	;
	;// (DDA.s)
	xld.w %r4, [%sp+24]	;// s.u
	add %r1, %r4
	xld.w %r4, [%sp+20]	;// s.d
	xld.w %r5, [%sp+16]	;// s.n * 2
	add %r4, %r5
	xjruge __draw_scanline_wz_2bit_step_s ;// !C
	xld.w %r5, [%sp+28]	;// s.v
	add %r1, %r5
	sub %r4, %r15
__draw_scanline_wz_2bit_step_s:
	xld.w [%sp+20], %r4	;// s.d
	;
	;// (DDA.t)
	xld.w %r4, [%sp+40]	;// t.u
	add %r2, %r4
	xld.w %r4, [%sp+36]	;// t.d
	xld.w %r5, [%sp+32]	;// t.n * 2
	add %r4, %r5
	xjruge __draw_scanline_wz_2bit_step_t ;// !C
	xld.w %r5, [%sp+44]	;// t.v
	add %r2, %r5
	sub %r4, %r15
__draw_scanline_wz_2bit_step_t:
	xld.w [%sp+36], %r4	;// t.d

	xsub %r7, %r7, 1
	xjrne __draw_scanline_wz_2bit_loop

__draw_scanline_wz_2bit_ret:
	xadd	%sp, %sp, 48
	popn	%r2
	ret
	");
#endif /*NOASM*/

#ifdef NOASM
/*static*/ void
draw_scanline_wz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(z);
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
			 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
			 * R[hTCYƂ̌ˍŁÂőË܂B
			 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
			 */
			sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
			tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
			ofs = param->texture_w * tval + sval;
			if(param->texture_mask[ofs / 8] >> (7 - (ofs & 7)) & 1) {
				/* 2biteNX`ȂAeNZl̂܂ܕ`܂B */
				*vptr = param->texture_buf[ofs / 4] >> (3 - (ofs & 3)) * 2 & 3;
				*zptr = zval;
			}
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		STEP2(z);
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}
#else /*NOASM*/
	asm("
	.align 1
	.global draw_scanline_wz_2bitmask
	;// IN:
	;// %r12     = v0
	;// %r13     = v1
	;// %r14     = param
draw_scanline_wz_2bitmask:
	;// USAGE:
	;// %r0      = cur.z
	;// %r1      = cur.s
	;// %r2      = cur.t
	;// [%sp+ 0] = DDA.z
	;// [%sp+16] = DDA.s
	;// [%sp+32] = DDA.t
	pushn %r2
	xsub %sp, %sp, 48

	;// m :v0 -> v1:E Ƃ܂B
	xld.uh %r4, [%r12+0]	;// v0->x
	xld.uh %r5, [%r13+0]	;// v1->x
	cmp %r4, %r5
	xjrule __draw_scanline_wz_2bitmask_swap
	xor %r12, %r13
	xor %r13, %r12
	xor %r12, %r13
__draw_scanline_wz_2bitmask_swap:
	;// %r12 = v0
	;// %r13 = v1

	;// n_AhX߂܂B
	xld.uh %r4, [%r14+0]	;// param->surface_w
	xld.uh %r5, [%r12+2]	;// v0->y
	mltu.h %r4, %r5
	ld.w %r4, %alr
	xld.uh %r5, [%r12+0]	;// v0->x
	add %r4, %r5
	xld.w %r10, [%r14+4]	;// param->surface_vbuff
	add %r10, %r4
	xld.w %r11, [%r14+8]	;// param->surface_zbuff
	add %r11, %r4
	;// %r10 = vptr
	;// %r11 = zptr
	;// %r5  = v0->x

	;// 厲DDAZbgAbvB
	xld.uh %r15, [%r13+0]	;// v1->x
	sub %r15, %r5
	xjreq __draw_scanline_wz_2bitmask_ret
	;// %r15 = nx

	;// DDAZbgAbvB
	;// (DDA.z)
	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
	xld.uh %r4, [%r13+4]	;// v1->z
	sub %r4, %r0
	xld.w %r5, 1
	xjruge __draw_scanline_wz_2bitmask_setup_z
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r5, -1
__draw_scanline_wz_2bitmask_setup_z:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r4, %ahr
	add %r4, %r4
	xld.w [%sp+ 0], %r4	;// z.n * 2
	not %r4, %r15
	xadd %r4, %r4, 1
	xld.w [%sp+ 4], %r4	;// z.d
	ld.w %r4, %alr
	mlt.h %r4, %r5
	ld.w %r4, %alr
	xld.w [%sp+ 8], %r4	;// z.u
	xld.w [%sp+12], %r5	;// z.v
	;// %r0      = cur.z
	;// [%sp+ 0] = z.n * 2
	;// [%sp+ 4] = z.d
	;// [%sp+ 8] = z.u
	;// [%sp+12] = z.v
	;
	;// (DDA.s)
	xld.uh %r1, [%r12+6]	;// v0->s => cur.s
	xld.uh %r4, [%r13+6]	;// v1->s
	sub %r4, %r1
	xld.w %r5, 1
	xjruge __draw_scanline_wz_2bitmask_setup_s
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r5, -1
__draw_scanline_wz_2bitmask_setup_s:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r4, %ahr
	add %r4, %r4
	xld.w [%sp+16], %r4	;// s.n * 2
	not %r4, %r15
	xadd %r4, %r4, 1
	xld.w [%sp+20], %r4	;// s.d
	ld.w %r4, %alr
	mlt.h %r4, %r5
	ld.w %r4, %alr
	xld.w [%sp+24], %r4	;// s.u
	xld.w [%sp+28], %r5	;// s.v
	;// %r1      = cur.s
	;// [%sp+16] = s.n * 2
	;// [%sp+20] = s.d
	;// [%sp+24] = s.u
	;// [%sp+28] = s.v
	;
	;// (DDA.t)
	xld.uh %r2, [%r12+8]	;// v0->t => cur.t
	xld.uh %r4, [%r13+8]	;// v1->t
	sub %r4, %r2
	xld.w %r5, 1
	xjruge __draw_scanline_wz_2bitmask_setup_t
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r5, -1
__draw_scanline_wz_2bitmask_setup_t:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r4, %ahr
	add %r4, %r4
	xld.w [%sp+32], %r4	;// t.n * 2
	not %r4, %r15
	xadd %r4, %r4, 1
	xld.w [%sp+36], %r4	;// t.d
	ld.w %r4, %alr
	mlt.h %r4, %r5
	ld.w %r4, %alr
	xld.w [%sp+40], %r4	;// t.u
	xld.w [%sp+44], %r5	;// t.v
	;// %r2      = cur.t
	;// [%sp+32] = t.n * 2
	;// [%sp+36] = t.d
	;// [%sp+40] = t.u
	;// [%sp+44] = t.v

	;// DDA[vB
	ld.w %r7, %r15
	add %r15, %r15
__draw_scanline_wz_2bitmask_loop:
	;// %r7  = n
	;// %r15 = nx * 2

	;// yrB
	ld.uh %r4, %r0		;// zval
	xsrl %r4, 8
	xld.ub %r5, [%r11]	;// *zptr
	cmp %r4, %r5
	xjrugt __draw_scanline_wz_2bitmask_skip
	;// %r4 = zval

	;// eNX`ItZbgvZB
	ld.uh %r5, %r2		;// tval
	xsrl %r5, 8
	xld.uh %r12, [%r14+14]	;// param->texture_h
	cmp %r5, %r12
	xjrult __draw_scanline_wz_2bitmask_wrap_t
	xrr %r5, 8
	ld.w %alr, %r5
	div0u %r12
	div1 %r12		;// 1
	div1 %r12		;// 2
	div1 %r12		;// 3
	div1 %r12		;// 4
	div1 %r12		;// 5
	div1 %r12		;// 6
	div1 %r12		;// 7
	div1 %r12		;// 8
	ld.w %r5, %ahr
__draw_scanline_wz_2bitmask_wrap_t:
	;// %r5 = tval
	;
	ld.uh %r6, %r1		;// sval
	xsrl %r6, 8
	xld.uh %r12, [%r14+12]	;// param->texture_w
	cmp %r6, %r12
	xjrult __draw_scanline_wz_2bitmask_wrap_s
	xrr %r6, 8
	ld.w %alr, %r6
	div0u %r12
	div1 %r12		;// 1
	div1 %r12		;// 2
	div1 %r12		;// 3
	div1 %r12		;// 4
	div1 %r12		;// 5
	div1 %r12		;// 6
	div1 %r12		;// 7
	div1 %r12		;// 8
	ld.w %r6, %ahr
__draw_scanline_wz_2bitmask_wrap_s:
	;// %r6  = sval
	;// %r12 = texture_w
	;
	mltu.h %r5, %r12
	ld.w %r12, %alr
	add %r12, %r6
	;// %r12 = ofs

	;// }XNeXgB
	xld.w %r5, [%r14+20]	;// param->texture_mask
	ld.w %r6, %r12
	xsrl %r6, 3
	add %r5, %r6
	xld.ub %r5, [%r5]
	;
	not %r6, %r12
	xand %r6, %r6, 7
	srl %r5, %r6		;// %r6=0`7Ȃ̂xsrlɂKvȂBxsrlɂƗ]vȃR[hĒxȂB
	xand %r5, %r5, 1
	xjreq __draw_scanline_wz_2bitmask_skip

	;// 2biteNX`ȂAeNZl̂܂ܕ`܂B */
	xld.w %r5, [%r14+16]	;// param->texture_buf
	ld.w %r6, %r12
	xsrl %r6, 2
	add %r5, %r6
	xld.ub %r5, [%r5]
	;
	not %r6, %r12
	xand %r6, %r6, 3
	add %r6, %r6
	srl %r5, %r6		;// %r6={0|2|4|6}Ȃ̂xsrlɂKvȂBxsrlɂƗ]vȃR[hĒxȂB
	xand %r5, %r5, 3
	;
	xld.b [%r10], %r5	;// *vptr
	xld.b [%r11], %r4	;// *zptr
__draw_scanline_wz_2bitmask_skip:

	;// obt@|C^i߂܂B
	xadd %r10, %r10, 1
	xadd %r11, %r11, 1

	;// DDAXebvsB
	;// (DDA.z)
	xld.w %r4, [%sp+ 8]	;// z.u
	add %r0, %r4
	xld.w %r4, [%sp+ 4]	;// z.d
	xld.w %r5, [%sp+ 0]	;// z.n * 2
	add %r4, %r5
	xjruge __draw_scanline_wz_2bitmask_step_z ;// !C
	xld.w %r5, [%sp+12]	;// z.v
	add %r0, %r5
	sub %r4, %r15
__draw_scanline_wz_2bitmask_step_z:
	xld.w [%sp+ 4], %r4	;// z.d
	;
	;// (DDA.s)
	xld.w %r4, [%sp+24]	;// s.u
	add %r1, %r4
	xld.w %r4, [%sp+20]	;// s.d
	xld.w %r5, [%sp+16]	;// s.n * 2
	add %r4, %r5
	xjruge __draw_scanline_wz_2bitmask_step_s ;// !C
	xld.w %r5, [%sp+28]	;// s.v
	add %r1, %r5
	sub %r4, %r15
__draw_scanline_wz_2bitmask_step_s:
	xld.w [%sp+20], %r4	;// s.d
	;
	;// (DDA.t)
	xld.w %r4, [%sp+40]	;// t.u
	add %r2, %r4
	xld.w %r4, [%sp+36]	;// t.d
	xld.w %r5, [%sp+32]	;// t.n * 2
	add %r4, %r5
	xjruge __draw_scanline_wz_2bitmask_step_t ;// !C
	xld.w %r5, [%sp+44]	;// t.v
	add %r2, %r5
	sub %r4, %r15
__draw_scanline_wz_2bitmask_step_t:
	xld.w [%sp+36], %r4	;// t.d

	xsub %r7, %r7, 1
	xjrne __draw_scanline_wz_2bitmask_loop

__draw_scanline_wz_2bitmask_ret:
	xadd	%sp, %sp, 48
	popn	%r2
	ret
	");
#endif /*NOASM*/

/****************************************************************************
 *	yRyAȂ
 ****************************************************************************/

/* v~eBu`܂B
 * [in]
 *	render				_[ւ̃|C^B
 *	n_vertices			_̐B
 *	render_work->rend_vertices	_XgB(O[oϐ)
 *	color				J[B
 */
static void
draw_primitive_woz(RENDER* render, int n_vertices, int color)
{
	struct {
		int iv;		/* ݂̕ӂ̏I_CfNX            */
		int ny;		/* ݂̕ӂ̍̕ψ                */
		int n;		/* ݂̕ӂ̎c胉C              */
		RENDVERTEX cur;	/* ݒl                              */
		DDA x;		/* _WDDA(y͍Eʂ1Âi) */
		DDA s, t;	/* eNX`WDDA                   */
	} sides[2], *side;

	int i, itop, y, top, bottom;
	RENDVERTEX *v, *v0, *v1;
	DSLPROC draw_scanline;
	DSLPARAM param;

	/* XLC`p[^܂B */
	draw_scanline = select_draw_scanline_woz(&param, render, color);

	/* ㉺[̈ʒuƁA[̒_߂܂B */
	itop = 0;
	top = bottom = render_work->rend_vertices[0].y;
	for(i = 1; i < n_vertices; i++) {
		v = &render_work->rend_vertices[i];
		if(v->y < top) {
			itop = i;
			top = v->y;
		}
		if(v->y > bottom) {
			bottom = v->y;
		}
	}
	if(top == bottom) return; /* |S͕`܂B */

	/* E̕ӂ܂B */
	for(i = 0; i < 2; i++) {
		side = &sides[i];
		side->iv = itop;
		side->n = 0; /* ɖ{̏s悤 */
	}

	/* [AeXLCɂ... */
	for(y = top; y < bottom; y++) {
		/* E̕ӂɂ... */
		for(i = 0; i < 2; i++) {
			side = &sides[i];
			/* ̕ӂɒB... */
			if(side->n == 0) {
				do {
					/* ̕ӂ̗[̒_߂܂B */
					v0 = &render_work->rend_vertices[side->iv];
					if(i == 0) {
						side->iv--;
						if(side->iv == -1) {
							side->iv = n_vertices - 1;
						}
					} else {
						side->iv++;
						if(side->iv == n_vertices) {
							side->iv = 0;
						}
					}
					v1 = &render_work->rend_vertices[side->iv];
					/* ̕ӂ̍̕ψʂ߂܂B */
					side->ny = v1->y - v0->y;
					/* V|SoAc̕`̓LZ܂B */
					if(side->ny < 0) return;
				} while(side->ny == 0); /* ȕӂ͖܂B */
				/* DDAZbgAbvB */
				SETUP1(x);
				SETUP1(s);
				SETUP1(t);
				/* ̕ӂ܂ł̃JE^B */
				side->n = side->ny;
			}
		}
		/* E̕ӂ̊ԂɁA`܂B */
		sides[0].cur.y = sides[1].cur.y = y;
		draw_scanline(&sides[0].cur, &sides[1].cur, &param);
		/* E̕ӂɂ... */
		for(i = 0; i < 2; i++) {
			side = &sides[i];
			/* ̕ӂ܂ł̃C炵܂B */
			side->n--;
			/* DDAXebvsB */
			STEP1(x)
			STEP1(s)
			STEP1(t)
		}
	}
	/* [̃XLC͕`܂B */
}

/* XLC`p[^܂B
 * [in]
 *	param		p[^\̂ւ̃|C^B
 *	render		_[ւ̃|C^B
 * [out]
 *	߂l		XLC`֐ւ̃|C^B
 * [note]
 *	* gȂo͏܂Bi[NA܂j
 */
static DSLPROC
select_draw_scanline_woz(DSLPARAM* param, RENDER* render, int color)
{
	SURFACE* surface = render->surface;
	TEXTURE* texture = render->context->texture;
	DSLPROC draw_scanline;

	/* T[tFCX */
	param->surface_w       = surface->w;
	param->surface_h       = surface->h;
	param->surface_vbuff   = surface->vbuff;
	//param->surface_zbuff = gȂ

	/* eNX`EJ[ */
	if(texture == NULL) {
		//param->texture_w    = gȂ
		//param->texture_h    = gȂ
		//param->texture_buf  = gȂ
		//param->texture_mask = gȂ
		param->back_color     = color & 15;
		//param->fore_color   = gȂ
		draw_scanline = draw_scanline_woz_color;
	} else {
		param->texture_w   = texture->header.w;
		param->texture_h   = texture->header.h;
		param->texture_buf = texture->buf;
		switch(texture->header.bpp) {
		case 1:
			if(!texture->header.mask) {
				//param->texture_mask = gȂ
				draw_scanline = draw_scanline_woz_1bit;
			} else {
				param->texture_mask = texture->mask;
				draw_scanline = draw_scanline_woz_1bitmask;
			}
			param->back_color = color      & 15;
			param->fore_color = color >> 4 & 15;
			break;
		default/*2*/:
			if(!texture->header.mask) {
				//param->texture_mask = gȂ
				draw_scanline = draw_scanline_woz_2bit;
			} else {
				param->texture_mask = texture->mask;
				draw_scanline = draw_scanline_woz_2bitmask;
			}
			//param->back_color = gȂ
			//param->fore_color = gȂ
			break;
		}
	}

	return draw_scanline;
}

/*static*/ void
draw_scanline_woz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	const RENDVERTEX* tmp;
	int ofs;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDA[vB */
	n = nx;
	do {
		/* eNX`ȂAtFCX̔wiFŕ`܂B */
		*vptr = param->back_color;
		/* obt@|C^i߂܂B */
		vptr++;
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

/*static*/ void
draw_scanline_woz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
		 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
		 * R[hTCYƂ̌ˍŁÂőË܂B
		 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
		 */
		sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
		tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
		ofs = param->texture_w * tval + sval;
		/* 1biteNX`ȂAeNZlɂ 1:tFCX̑OiF/0:tFCX̔wiF ŕ`܂B */
		*vptr = param->texture_buf[ofs / 8] >> (7 - (ofs & 7)) & 1 ? param->fore_color : param->back_color;
		/* obt@|C^i߂܂B */
		vptr++;
		/* DDAXebvsB */
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

/*static*/ void
draw_scanline_woz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
		 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
		 * R[hTCYƂ̌ˍŁÂőË܂B
		 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
		 */
		sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
		tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
		ofs = param->texture_w * tval + sval;
		if(param->texture_mask[ofs / 8] >> (7 - (ofs & 7)) & 1) {
			/* 1biteNX`ȂAeNZlɂ 1:tFCX̑OiF/0:tFCX̔wiF ŕ`܂B */
			*vptr = param->texture_buf[ofs / 8] >> (7 - (ofs & 7)) & 1 ? param->fore_color : param->back_color;
		}
		/* obt@|C^i߂܂B */
		vptr++;
		/* DDAXebvsB */
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

/*static*/ void
draw_scanline_woz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
		 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
		 * R[hTCYƂ̌ˍŁÂőË܂B
		 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
		 */
		sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
		tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
		ofs = param->texture_w * tval + sval;
		/* 2biteNX`ȂAeNZl̂܂ܕ`܂B */
		*vptr = param->texture_buf[ofs / 4] >> (3 - (ofs & 3)) * 2 & 3;
		/* obt@|C^i߂܂B */
		vptr++;
		/* DDAXebvsB */
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

/*static*/ void
draw_scanline_woz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA s, t;		/* eNX`WDDA          */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char sval, tval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(s);
	SETUP2(t);

	/* DDA[vB */
	n = nx;
	do {
		/* P/ECE͏Zx̂ŁAZ̗vEsv𔻒肵Ă珜Zsق܂}VłB
		 * eNX`WWrapȂꍇ̃XLC`R[hWJ΁Aɍł܂A
		 * R[hTCYƂ̌ˍŁÂőË܂B
		 * xr̎Qll: ɏZ(100%)->肵ďZ(150%)->R[hWJ(110%)
		 */
		sval = (unsigned char)(cur.s >> 8); if(sval >= param->texture_w) sval %= param->texture_w;
		tval = (unsigned char)(cur.t >> 8); if(tval >= param->texture_h) tval %= param->texture_h;
		ofs = param->texture_w * tval + sval;
		if(param->texture_mask[ofs / 8] >> (7 - (ofs & 7)) & 1) {
			/* 2biteNX`ȂAeNZl̂܂ܕ`܂B */
			*vptr = param->texture_buf[ofs / 4] >> (3 - (ofs & 3)) * 2 & 3;
		}
		/* obt@|C^i߂܂B */
		vptr++;
		/* DDAXebvsB */
		STEP2(s);
		STEP2(t);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}

#undef SETUP1
#undef STEP1
#undef SETUP2
#undef STEP2
