/*
 *	main.c
 *
 *	g[X
 *
 *	* Mon Mar 31 19:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
unsigned char zbuff[DISP_X * DISP_Y];	/* Zobt@ */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
extern const unsigned char BG[];
TEXTURE pat;
TEXTURE bg;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	surface.zbuff = zbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	/* rbg}bvB */
	texture_init(&pat, PAT);
	texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	run
 ****************************************************************************/

#define Tcur	(render.context->matrix)

#define R1	2	/* `[u̔a */
#define R2	5	/* O̔a */

#define DIV1	10	/* `[u͉p`H */
#define DIV2	20	/* O͉p`H */

typedef struct _FACE4 {
	FACE f;
	FACEVERTEX fv[4];
} FACE4;

struct {
	MESH mesh;
	vector vectors[DIV2][DIV1];
	TCOORD tcoords[DIV2 + 1][DIV1 + 1];
	FACE4 faces[DIV2][DIV1];
} torus;
#define mesh	torus.mesh
#define tcoords	torus.tcoords
#define faces	torus.faces
#define vectors	torus.vectors

void
run()
{
	static unsigned char vbuff_save[DISP_X * DISP_Y];
	unsigned char c, *dst, *src;
	int i, j;
	int t[10], it, tc, dt, fps;
	fixed r, x, y, z, rx, ry, rz;
	vector v[DIV1];
	matrix m;

	mesh.nv = DIV1 * DIV2;
	mesh.nc = (DIV1 + 1) * (DIV2 + 1);
	mesh.nf = DIV1 * DIV2;

	for(i = 0; i < DIV1; i++) {
		r = fidiv(fimul(PI2, i + DIV1 / 3), DIV1);
		x = fimul(fcos(r), R1);
		y = fimul(fsin(r), R1);
		z = 0;
		v[i] = (vector){x, y, z};
	}

	for(i = 0; i < DIV2 + 1; i++) {
		for(j = 0; j < DIV1 + 1; j++) {
			tcoords[i][j].s = DISP_X * i / DIV2;
			tcoords[i][j].t = DISP_Y * j / DIV1;
		}
	}

	for(i = 0; i < DIV2; i++) {
		r = fidiv(fimul(PI2, i), DIV2);
		m = MATRIX_I;
		m = mroty(m, r);
		m = mxlate(m, fld(R2), 0, 0);
		for(j = 0; j < DIV1; j++) {
			vectors[i][j] = vxform(m, v[j]);

			faces[i][j].f.nfv = 4;
			faces[i][j].f.c = (i ^ j) & 1 ? 1 : 2;
			//
			faces[i][j].fv[0].iv = (( i            ) * DIV1) + ( j            );
			faces[i][j].fv[1].iv = (((i + 1) % DIV2) * DIV1) + ( j            );
			faces[i][j].fv[2].iv = (((i + 1) % DIV2) * DIV1) + ((j + 1) % DIV1);
			faces[i][j].fv[3].iv = (( i            ) * DIV1) + ((j + 1) % DIV1);
			//
			faces[i][j].fv[0].ic = ((i    ) * (DIV1 + 1)) + (j    );
			faces[i][j].fv[1].ic = ((i + 1) * (DIV1 + 1)) + (j    );
			faces[i][j].fv[2].ic = ((i + 1) * (DIV1 + 1)) + (j + 1);
			faces[i][j].fv[3].ic = ((i    ) * (DIV1 + 1)) + (j + 1);
		}
	}

	render_init(&render, &surface,
		0, 0, 0, 0,
		fld(1), fld(20), fidiv(PI, 3));
	Tcur = mlookat(Tcur, 0,fld(10),fld(-10), 0,0,0, 0);

	render.context->texture = &pat;
	render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
	dst = vbuff_save;
	src = vbuff;
	for(i = 0; i < DISP_Y; i++) {
		for(j = 0; j < DISP_X; j++) {
			c = *src++;
			c += (i ^ j) & 1 ? 1 : 2;
			if(c > 3) c = 3;
			*dst++ = c;
		}
	}

	it = 0;
	rx = 0;
	ry = 0;
	rz = 0;
	for(;;) {
		schedule();
		if(joy & TRG_MASK) break;

		//surface_clear(&surface, 0);
		memset(zbuff, -1, sizeof zbuff);
		memcpy(vbuff, vbuff_save, sizeof vbuff);

		render_save(&render);
		Tcur = mrotxyz(Tcur, rx, ry, rz);
		render.context->texture = &bg;
		render_mesh(&render, &mesh);
		render_restore(&render);
		rx = fadd(rx, fidiv(PI, 50));
		ry = fadd(ry, fidiv(PI, 60));
		rz = fadd(rz, fidiv(PI, 70));

		tc = pceTimerGetCount();
		dt = tc - t[it];
		if(dt > 0) {
			fps = 10 * 1000 / dt;
			render_printf_framed(&render, 0, 0, 0, 0x203, "%2d[FPS]", fps);
		}
		t[it] = tc;
		if(++it == 10) it = 0;
	}
}
